* FAST GROB VIEWER/SCROLLER
* Randy Ding, randyd@alpha2.csd.uwm.edu
* June 15,1994
* grob can be any size
* stack:   1: GROB  -->
*
* <arrow keys> scroll if grob is larger than display, hold down for repeat
* right-shift of <arrow keys> jumps to extreme edge of grob
* <VAR> key switches between x1 and x10 scroll speed
* <ON> key exits

INCLUDE C:\HPTOOLS\KEYDEFS.H

ASSEMBLE
           NIBASC  /HPHP48-E/
RPL

::
 CK1NOLASTWD
 CK&DISPATCH1 TWELVE           ( *GRAPHIC OBJECT* )
 ::
  RECLAIMDISP
  ClrDA1IsStat
  ZEROZERO
  ROT                          ( *x, y, grob* )
  XYGROBDISP
  TURNMENUOFF
  HARDBUFF
  GROBDIM                      ( *height, width* )
  FALSETRUE                    ( *EXIT CONDITION FLAG, slow scroll flag* )

* push key delay subroutine, does small delay if key held down
* stored in LAM delay, to execute: recall then EVAL it
* stack:  key code -->
*
  ' ::
     EIGHT                     ( *delay count* )
     BEGIN
      % 0.01
      Wait/GetKey              ( *small wait* )
      #1-
      DUP
      #0=
      3PICK
      REPKEY?                  ( *exit delay loop sooner if key released* )
      NOT OR
     UNTIL
     2DROP                     ( *key code and count* )
    ;

  { LAM Height                 ( *HARDBUFF height* )
    LAM Width                  ( *HARDBUFF width* )
    LAM Exit                   ( *goes true when ON pressed* )
    LAM Slow                   ( *TRUE: x1, FALSE: x10* )
    LAM delay }                ( *subroutine* )
  BIND

* push 9 ParOuterLoop parameters
* AppDisplay, AppKeys, NonAppKeyOK, DoStdKeys, AppMenu, #AppMenuRow,
* SuspendOK?, ExitCond, AppError
*
  'NOP                         ( *APPDISPLAY* )

* -------------------------- begin AppKeys --------------------------------

  ' ::                         ( *APPKEYS --long--* )

     kpNoShift #=casedrop      ( *decode no-shift-plane* )
     ::

      kcVarsMenu ?CaseKeyDef   ( *VAR key, change fast/slow scroll mode* )
      ::
       TakeOver
       LAM Slow
       NOT
       ' LAM Slow
       STOLAM
      ;

      kcUpArrow ?CaseKeyDef    ( *UpArrow handler, other three are similar* )
      ::
       TakeOver
       LAM Slow
       case SCROLLUP           ( *do x1 slow scroll and thats all* )
                               ( *SCROLLxxx has built in repeat loop* )

       kcUpArrow LAM delay     ( *place key code and delay routine on stack* )
                               ( *its eval'd after first pass thru then* )
                               ( *replaced with a NOP for subsequent passes* )

       BEGIN                   ( *start x10 fast scroll key repeat loop* )
        ::
         TOPROW                ( *test range* )
         TEN #<
         case JUMPTOP          ( *out of range, scroll top then test repeat* )
         WINDOWCORNER          ( * --> y,x* )
         SWAP
         TEN #-                ( *move up 10 rows* )
         SWAP
         WINDOWXY              ( *y,x --> * )
        ;
        EVAL 'NOP              ( *eval delay routine, then replace with NOP* )
                               ( *delay is only for end of first pass* )
                               ( *delay terminates sooner if key released* )
        kcUpArrow
        REPKEY? NOT            ( *test if UpArrow held down* )
       UNTIL                   ( *exit loop when released* )
       DROP                    ( *NOP* )
      ;                        ( *end UpArrow handler* )

      kcLeftArrow ?CaseKeyDef  ( *LeftArrow handler* )
      ::
       TakeOver
       LAM Slow
       case SCROLLLEFT
       kcLeftArrow LAM delay
       BEGIN
        ::
         LEFTCOL
         TEN #<
         case JUMPLEFT
         WINDOWCORNER
         TEN #-
         WINDOWXY
        ;
        EVAL 'NOP
        kcLeftArrow
        REPKEY? NOT
       UNTIL
       DROP
      ;

      kcRightArrow ?CaseKeyDef ( *RightArrow handler* )
      ::
       TakeOver
       LAM Slow
       case SCROLLRIGHT
       kcRightArrow LAM delay
       BEGIN
        ::
         RIGHTCOL
         #10+
         LAM Width
         #<
         NOTcase JUMPRIGHT
         WINDOWCORNER
         #10+
         WINDOWXY
        ;
        EVAL 'NOP
        kcRightArrow
        REPKEY? NOT
       UNTIL
       DROP
      ;

      kcDownArrow ?CaseKeyDef  ( *DownArrow handler* )
      ::
       TakeOver
       LAM Slow
       case SCROLLDOWN
       kcDownArrow LAM delay
       BEGIN
        ::
         BOTROW
         #10+
         LAM Height
         #<
         NOTcase JUMPBOT
         WINDOWCORNER
         SWAP
         #10+
         SWAP
         WINDOWXY
        ;
        EVAL 'NOP
        kcDownArrow
        REPKEY? NOT
       UNTIL
       DROP
      ;

      kcOn ?CaseKeyDef         ( *ON key handler, set flag to exit program* )
      :: TakeOver TRUE ' LAM Exit STOLAM ;

      kcRightShift #=casedrpfls
      DROP 'DoBadKeyT
     ;                         ( *end of no-shift-plane decoder* )

     kpRightShift #=casedrop   ( *decode right-shift-plane* )
     ::
      kcUpArrow ?CaseKeyDef
      :: TakeOver JUMPTOP ;
      kcLeftArrow ?CaseKeyDef
      :: TakeOver JUMPLEFT ;
      kcRightArrow ?CaseKeyDef
      :: TakeOver JUMPRIGHT ;
      kcDownArrow ?CaseKeyDef
      :: TakeOver JUMPBOT ;
      kcRightShift #=casedrpfls
      DROP 'DoBadKeyT
     ;
     2DROP 'DoBadKeyT
    ;

* ^^^^^^^^^^^^^^^^^^^^^^^^^^ end of AppKeys ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^


  TrueTrue                     ( *NONAPPKEYOK, DOSTDKEYS* )
  FALSE                        ( *APPMENU* )
  ONEFALSE                     ( *#APPMENUROW, SUSPENDOK* )
  ' LAM Exit                   ( *EXIT CONDITION* )
  ' ERRJMP                     ( *APPERROR* )
  ParOuterLoop
  ABND
  TURNMENUON
  RECLAIMDISP
  ClrDAsOK
 ;
;
