**********************************************************************
* Desc:		Brent-Pollard factorization for N < 2^128
* Stack:	( Z --> Z1 Z2 )
* Notes:	This is an almost direct translation of the ALG48
*		Brent-Pollard factorization subroutine (srpl).
*
*		Output not trimmed
*
*		Not fast enough to be included in ALG48
**********************************************************************
CODE

sGOODZ	EQU 9
M	EQU 10

	ABASE	#80100
Z	ALLOC	32
X	ALLOC	32
Y	ALLOC	32
Q	ALLOC	32
YS	ALLOC	32
K	ALLOC	5
R	ALLOC	5	= #AA

	GOSBVL	=SAVPTR
	A=DAT1	A
	D0=A
	GOSUB	POPZ2
	R0=A		01=N
	R1=C

	D0=(5)	=IRAM@
	C=DAT0	S
	D0=(5)	#80100		GX
	C=C+C	S
	GOC	+
	D0=(5)	#70100		SX
+
	B=0	W	Y=0
	D=0	W
	GOSUB	Y=BD
	D=D+1	W	Q=1
	GOSUB	Q=BD
	GOSUB	R=C	R=1

BRENTLOOP
	C=0	A	K=0
	GOSUB	K=C

	GOSUB	BD=Y	X=Y
	GOSUB	X=BD

* Y=Y^2+3 @N R times

	GOSUB	C=R
	R4=C
	GOSUB	BD=Y
-	GOSUB	SQn
	GOSUB	ADDn3
	C=R4
	C=C-1	A	I--
	R4=C
	?C#0	A
	GOYES	-
	GOSUB	Y=BD

BRENTLP2
	GOSUB	BD=Y	YS=Y
	GOSUB	YS=BD

* LOOP COUNT: MIN[M,R-K]
	GOSUB	C=R
	A=C	A
	GOSUB	C=K
	A=A-C	A	R-K
	LC(5)	M
	?C<=A	A
	GOYES	+
	C=A	A
+	R4=C		I
BRENTFOR
	GOSUB	BD=Y	Y=Y^2+3 @N
	GOSUB	SQn
	GOSUB	ADDn3
	GOSUB	Y=BD
	GOSUB	AC=X	ABS(X-Y)
	GOSUB	BD=MAX
	D=D-C	W
	GONC	+
	B=B-1	W
+	B=B-A	W
	GOSUB	AC=Q	Q=Q*ABS(X-Y) @N
	GOSUB	MULn
	GOSUB	Q=BD
	C=R4
	C=C-1	A	I--
	R4=C
	?C#0	A
	GOYES	BRENTFOR

	GOSUB	GCDn	Z=GCD(Q,N)
	GOSUB	Z=BD	

	ST=1	sGOODZ
	?B#0	W
	GOYES	+
	D=D-1	W
	?D#0	W
	GOYES	+
	ST=0	sGOODZ
+
	GOSUB	C=K	K+=M
	A=C	A
	LC(5)	M
	A=A+C	A
	DAT0=A	A
	D0=(2)	R
	C=DAT0	A
	?A>=C	A
	GOYES	endlp2	K>=R
	?ST=1	sGOODZ
	GOYES	endlp2
	GOTO	BRENTLP2

* K>=R or Z<>1

endlp2	C=C+C	A	R*=2
	DAT0=C	A
	?ST=1	sGOODZ
	GOYES	+
	GOTO	BRENTLOOP
+

* Z<>1, see if true factor
* (Lets assume so!)

	GOSUB	AC=Z
	R2=A
	R3=C
	LC(5)	33
	GOSBVL	=MAKE$N
	D0=D0-	10
	LC(5)	=DOHSTR
	DAT0=C	A
	D0=D0+	10
	C=R3
	DAT0=C	W
	D0=D0+	16
	C=R2
	DAT0=C	W
	D0=D0+	16
	C=0	A
	DAT0=C	1
	GOVLNG	=GPPushR0Lp

*********************************
BD=MAX	?B>A	W
	RTNYES
	?B<A	W
	GOYES	+
	?D>=C	W
	RTNYES
+	ABEX	W
	CDEX	W
	RTN
*********************************
* BD = BD^2 MOD N
*********************************
SQn	A=B	W
	C=D	W
*********************************
* BD = AC*BD MOD N
*********************************
MULn	GOSUB	BD=MAX
	R2=A		23 = min
	R3=C
	A=B	W	AC = max
	C=D	W
	B=0	W	res=0
	D=0	W
MULnlp	AR2EX
	CR3EX
	?A#0	W
	GOYES	+
	?C=0	W
	RTNYES
+	GOSUB	HALF
	AR2EX
	CR3EX
	?SB=0
	GOYES	+
	GOSUB	ADDn
+	ABEX	W
	CDEX	W
	GOSUB	DOUBLE
	ABEX	W
	CDEX	W
	GOTO	MULnlp
*********************************
* BD += 3  MOD N
*********************************
ADDn3	A=0	W
	C=0	W
	LC(1)	3
*********************************
* BD += AC MOD N
*********************************
ADDn	D=D+C	W
	GOC	+
	B=B+A	W
	GOC	SUBn
	GONC	MODn
+	B=B+A	W
	GONC	+
	B=B+1	W
	GONC	SUBn
+	B=B+1	W
	GOC	SUBn
*********************************
* BD MOD N
*********************************
MODn	AR0EX
	CR1EX
	?B<A	W
	GOYES	swapn
	?B>A	W
	GOYES	subn
	?D<C	W
	GOYES	swapn
	GONC	subn
SUBn	AR0EX
	CR1EX
subn	D=D-C	W
	GONC	+
	B=B-1	W
+	B=B-A	W
swapn	AR0EX
	CR1EX
	RTN
*********************************
* BD = 2*BD MOD N
*********************************
DOUBLE	D=D+D	W
	GOC	+
	B=B+B	W
	GONC	MODn
	GOC	SUBn
+	B=B+B	W
	GONC	+
	B=B+1	W
	GONC	SUBn
+	B=B+1	W
	GONC	MODn
	GOC	SUBn
*********************************
* AC = AC/2
* SB = lost bit
*********************************
HALF	SB=0
	ASRB
	?SB=0
	GOYES	+
	SB=0
	CSRB
	C=C+CON	S,8
	RTN
+	CSRB
	RTN
*********************************
* BD = GCD(BD,N)
* !!!!Where N is odd!!!!
*********************************
GCDn	C=D	W
-	?CBIT=1	0
	GOYES	+
	CSRB
	SB=0
	BSRB
	?SB=0
	GOYES	-
	C=C+CON	S,8
	GONC	-
+	D=C	W
	A=R0
	C=R1
GCDlp	?A>B	W	AC=MAX
	GOYES	++
	?A<B	W
	GOYES	+
	?C>=D	W
	GOYES	++
+	ABEX	W
	CDEX	W
++	C=C-D	W	AC=MAX-MIN
	GONC	+
	A=A-1	W
+	A=A-B	W
	?A#0	W
	GOYES	GCDhalf
	?C=0	W
	RTNYES
GCDhalf	CSRB		2's out
	SB=0
	ASRB
	?SB=0
	GOYES	+
	C=C+CON	S,8
+	?CBIT=0	0
	GOYES	GCDhalf
	GONC	GCDlp
*********************************
AC=Z	D0=(2)	Z
	GOTO	getac
Z=BD	D0=(2)	Z
	GOTO	putbd
*********************************
AC=X	D0=(2)	X
	GOTO	getac
X=BD	D0=(2)	X
	GOTO	putbd
*********************************
AC=Y	D0=(2)	Y
	GOTO	getac
Y=BD	D0=(2)	Y
	GOTO	putbd
BD=Y	GOSUB	AC=Y
	B=A	W
	D=C	W
	RTN
*********************************
AC=Q	D0=(2)	Q
	GOTO	getac
Q=BD	D0=(2)	Q
	GOTO	putbd
*********************************
AC=YS	D0=(2)	YS
	GOTO	getac
YS=BD	D0=(2)	YS
	GOTO	putbd
*********************************
getac	C=DAT0	W
	D0=D0+	16
	A=DAT0	W
	RTN
putbd	C=D	W
	A=B	W
	DAT0=C	W
	D0=D0+	16
	DAT0=A	W
	RTN	
*********************************
K=C	D0=(2)	K
	DAT0=C	A
	RTN
C=K	D0=(2)	K
	C=DAT0	A
	RTN
*********************************
R=C	D0=(2)	R
	DAT0=C	A
	RTN
C=R	D0=(2)	R
	C=DAT0	A
	RTN
*********************************
POPZ2	D0=D0+	5
	C=DAT0	A
	D0=D0+	5
	C=C-CON	A,7
	CPEX	0
	A=0	W
	?C#0	A
	GOYES	+
	C=0	W
	C=DAT0	WP
	P=	0
	RTN
+	C=C-CON	A,16
	?C#0	A
	GOYES	popz2err
	C=DAT0	W
	D0=D0+	16
	A=DAT0	WP
	P=	0
	RTN
popz2err
	P=	0
	LC(5)	=SYNTAXERR
	GOVLNG	=GETPTREVALC
*********************************
ENDCODE
