**********************************************************************
* Desc:		Shank's square forms factorization
* Stack:	( Z --> Z1 Z2 %loops )
*		or % or $
* Calls:	ID SQRT		( Z --> sqrt(z) exact? )
* Notes:
*		This depends on N, not P (the factor)
*
*		See UBasic programs by Malm
*
*		This is Jazz source code
**********************************************************************

DEFINE UBnd 2000

::
  CK1NOLASTWD
  FastLib CK1Z			( N )
  NULLHXS			( H1 )
  HXS 2 10			( H2=1 )
  NULLHXS			( P )
  NULLHXS			( Q )
  HXS 1 0			( Pp=0 )
  HXS 2 10			( Qq=1 )
  7PICK				( Qqq=N )
  NULLHXS			( Te )
  NULLHXS			( A )
  HXS 1 0			( R=0 )
  NULLHXS			( K )
  ZERO				( I )
  {{ N H1 H2 P Q Pp Qq Qqq Te A R K I }}

  N ID SQRT case	:: DUP ABND ;

  K!
  K H1! K A!
  BEGIN
	I #1+ I!
	I UBnd #> case
	:: RDROP N HXS 1 0 ABND ;
	I #>$ DISPROW1

	K R QSub P!				( P = K-R )
	Qqq A Pp P QSub QMul QAdd Q!		( Q=Qqq+A*[Pp-P] )
	P K QAdd Q QDivRem R! A!		( A=[P+K]/Q ; R=remainder )
	A H1 QMul H2 QAdd Te!			( Te=A*H1+H2 )
	H1 H2!					( H2=H1 )
	Te H1!					( H1=Te )
	P Pp!					( Pp=P )
	Qq Qqq!					( Qqq=Qq )
	Q Qq!					( Qq=Q )
	Q ID SQRT SWAP Te!			( Te=sqrt[Q] )
  ?SKIP AGAIN
	I ONE #AND #0<>	
  IT AGAIN
	H2 Te QSub Te!				( Te=H2-Te )
	Te N ZGcd				( gcd[Te,N] )
	DupZIsOne?
  casedrop :: AGAIN ;
	DUP N EQUAL
  casedrop :: AGAIN ;
  RDROP
  N OVER QDiv
  I UNCOERCE ABND
;
**********************************************************************

