	STITLE	ALG MetaS
**********************************************************************
*		ALG library: Meta Symbolic operations
**********************************************************************


**********************************************************************
* EXPORT:
*
*   CKSymb1	( obj --> symb )
*   CKSymbN	( Meta --> symb )
*
*   SNeg	( Meta --> Meta&NEG )
*   SSign	( sflag Meta --> Meta' )
*   SAdd	( Meta1 Meta2 --> Meta )
*   SSub	( Meta1 Meta2 --> Meta )
*   SMul	( Meta1 Meta2 --> Meta )
*   SDiv	( Meta1 Meta2 --> Meta )
*   SPow#	( Meta # --> Meta' )
**********************************************************************



**********************************************************************
* Desc:		Make a symbolic of obj
* Stack:	( obj --> symb )
**********************************************************************
NULLNAME CKSymb1
::
  CK&DISPATCH0
	real	NOP
	sym	NOP
	seco	ONESYMBN
;
**********************************************************************
* Desc:		Make a symbolic of meta
* Stack:	( Meta --> symb )
**********************************************************************
NULLNAME CKSymbN
::
   ONE #=casedrop CKSymb1
   SYMBN
;

**********************************************************************
* Desc:		Negate Meta symbolic
* Stack:	( Meta --> Meta&NEG )
**********************************************************************
NULLNAME SNeg
::
  M-1stcasechs NOP
  OVER REALcase :: SWAP %CHS SWAP ;
  onlyputopCHS
;
	
**********************************************************************
* Desc:		Set sign of meta symbolic according to sflag
* Stack:	( sflag Meta --> Meta' )
**********************************************************************
NULLNAME SSign
::
  get1				( Meta sflag )
  NOT?SEMI			( return Meta )
  SNeg			 	( Meta' )
;

**********************************************************************
* Desc:		Add two meta symbolics. If Meta1 is #0 then Meta=Meta2
* Stack:	( Meta1 Meta2 --> Meta )
**********************************************************************
NULLNAME SAdd
::
  get1			( Meta1- Meta2 n1 )
  DUP#0=csDROP		( return Meta2 )
  #+			( Meta1&Meta2 )
  onlyputop+			( Meta1&Meta2&+ )
;

**********************************************************************
* Desc:		Substract two meta symbolics. If Meta1 is #0 then
*		Meta=Meta2&NEG
* Stack:	( Meta1 Meta2 --> Meta )
**********************************************************************
NULLNAME SSub
::
  get1				( Meta1- Meta2 n1 )
  DUP#0=csedrp onlyputopCHS 	( return Meta2&NEG )
  #+				( Meta1&Meta2 )
  onlyputop-			( Meta1&Meta2&- )
;


**********************************************************************
* Desc:		Multiply two meta symbolics. If Meta1 is #0 then Meta=Meta2
* Stack:	( Meta1 Meta2 --> Meta )
**********************************************************************
NULLNAME SMul
::
  get1			( Meta1- Meta2 n1 )
  DUP#0=csDROP		( return Meta2 )
  #+			( Meta1&Meta2 )
  onlyputop*		( Meta1&Meta2&* )
;

**********************************************************************
* Desc:		Divide two meta symbolics
* Stack:	( Meta1 Meta2 --> Meta )
**********************************************************************
NULLNAME SDiv
::
   top& 			( Meta1&Meta2 )
   putop: x/			( Meta )
;

**********************************************************************
* Desc:		Raise meta symbolic to positive (>0) power
* Stack:	( Meta # --> Meta' )
**********************************************************************
NULLNAME SPow#
::
  DUP#1= caseDROP		( return Meta )
  UNCOERCE			( Meta % )
  SWAP#1+			( Meta&% )
  putop: x^			( Meta&%&^ )
;

**********************************************************************
