	STITLE	ALG48 ASIM Command

**********************************************************************
*		Externals
**********************************************************************


**********************************************************************
*		Unsupported Entries
**********************************************************************
ASSEMBLE

* In global.s

RPL

**********************************************************************
*		Programs
**********************************************************************

**********************************************************************
* Name:		xASIM
* Desc:		Full algebraic simplification
* Stack:	( sym --> sym' )
* Notes:	Moved to alguser.s to fix position in command menu.
**********************************************************************
*ASSEMBLE
*	CON(1)	8
*RPL
*xNAME ASIM
*::
*  CK1&Dispatch 
*	real	NOP
*	cmp	:: SimpOb SYMBN ;		( No FastLib needed )
*	symb	:: FastLib ASim ;
*	sym	NOP
*	list	:: FastLib RESOROMP ASim DoP ;
*; 
*
*
**********************************************************************
* Desc:		Recursively simplify symbolic into rational form
* Stack:	( Sym Sym' )
**********************************************************************
NULLNAME ASim
::
   CK&DISPATCH0
	real	NOP
	idnt	NOP
	lam	NOP
	symb	ASimSym
;

**********************************************************************
* Desc:		Recursively simplify symbolic into rational form
* Stack:	( Sym Sym' )
**********************************************************************

* The certainty lam is set to false if we obtain simplifications
* in MergeSym phase which could cause further simplifications
* for the ASimMeta phase. This takes care of situations when
* trigonometric simplifications have ramifications for upper level
* functions, possibly all the way up to the topmost one.
* Note that execution time is *not* doubled because ASimMeta usually
* ends up doing its job a lot quicker.

DEFINE certain?		1GETLAM
DEFINE certain		TRUE 1PUTLAM
DEFINE notcertain	FALSE 1PUTLAM

NULLNAME ASimSym
::
  TRUE 1LAMBIND					( Init certainty lam )
  BEGIN
	certain					( Assume result is fine )
	BEGIN					( Fully expand and simplify )
	   DUP
	   syminner ASimMeta CKSymbN RSim
	   DUPUNROT EQUAL
	UNTIL
	MergeSym				( Collect + simplify )
	certain?
  UNTIL						( Until result is fine )
  ABND
;

**********************************************************************
* Function dispatcher for speed and *size*
**********************************************************************

ASSEMBLE

FCNREL	MACRO
	CON(5)	=$1
	CON(5)	(($2)-(*))!#80000	High bit always set
FCNREL	ENDM

FCNABS	MACRO
	CON(5)	=$1
	CON(5)	=$2			High bit always clear
FCNABS	ENDM

FCNEND	MACRO
	CON(5)	0
FCNEND	ENDM


FcnDispatch:	C=RSTK
		CD0EX
		RSTK=C			RSTK = "D0"
		D1=D1+	5
		A=DAT1	A		fcn
		D1=D1-	5

-		C=DAT0	A		Dispatch loop
		D0=D0+	10		
		?C=0	A
		GOYES	fdsptchend	No match - continue
		?A#C	A
		GOYES	-
		D0=D0-	5
		A=DAT0	A		offset/absolute value
		A=A+A	A		CS if offset
		GOC	fdsptchrel

fdsptchabs	A=DAT0	A		->dispatchee
		C=RSTK			Restore D0
		D0=C
		GOVLNG	=DOBINT		And push ROM address to stack

fdsptchrel	C=A	A
		ASRB.F	A
		C=C+C	A		CS if offset is negative
		GONC	+
		ASRC
		ABIT=1	15		Expand to 20 bits
		ASLC
+		C=RSTK
		CD0EX
		A=A+C	A		->dispatchee
		GOVLNG	=DOBINT

fdsptchend	C=RSTK
		D0=C
		GOSBVL	=SKIPOB		Skip next object
		GOVLNG	=Loop		And continue
RPL

**********************************************************************
* Desc:		Simplify subexpressions of Meta
* Stack:	( Meta --> Meta' )
**********************************************************************
NULLNAME ASimMeta
::
   ?ATTNQUIT

   OVER TYPESYMB? case			( Implode embedded symbolics )
   :: #1-SWAP syminner top& ASimMeta ;

   DUP#1= casedrop SimpOb		( Regular objects )

   CODE
		GOSUB	FcnDispatch:

		FCNREL	x+,Simp+
		FCNREL	x-,Simp-
		FCNREL	x*,Simp*
		FCNREL	x/,Simp/
		FCNREL	xNEG,SimpNeg
		FCNREL	xINV,SimpInv
		FCNREL	xSQ,SimpSq
		FCNREL	x^,SimpPow
		FCNREL	xSQRT,SimpSqrt
		FCNREL	xEXP,SimpExp
		FCNREL	xALOG,SimpALog
		FCNREL	xLN,SimpLn
		FCNREL	xLOG,SimpLog
		FCNREL	xSIN,SimpSin
		FCNREL	xCOS,SimpCos
		FCNREL	xTAN,SimpTan
		FCNREL	xASIN,SimpASin
		FCNREL	xACOS,SimpACos
		FCNREL	xATAN,SimpATan
		FCNREL	xSINH,SimpSinh
		FCNREL	xCOSH,SimpCosh
		FCNREL	xTANH,SimpTanh
		FCNREL	xASINH,SimpASinh
		FCNREL	xACOSH,SimpACosh
		FCNREL	xATANH,SimpATanh
		FCNREL	xABS,SimpAbs
		FCNREL	xRE,SimpRe
		FCNREL	xIM,SimpIm
		FCNREL	xCONJ,SimpConj
		FCNEND
   ENDCODE
   COLA_EVAL

* Unknown function remains - simplify arguments & rebuild

   #1-SWAP OVER#2+UNROLL		( fcn Meta )
   pshzer				( fcn #0 Meta )

   BEGIN
	splitonearg			( fcn M Meta' MetaN )
	SimpMeta			( fcn M Meta' MetaN' )
	roll2ND top& psh		( fcn M' Meta' )
	DUP#0=
   UNTIL
   DROP
   get1 SWAP#1+
   veryunsymin syminner			( Normalize Meta )
;

* Some utilities to shorten program size
* The size test is required for FCNAPPLY to work properly.
NULLNAME RSimMeta
:: DUP#1= ?SEMI SYMBN RSim syminner ;

NULLNAME RFctrMeta
:: CKSymbN FFactor syminner ;

NULLNAME SimpMeta1
::
  pullDROP
  NULLNAME SimpMeta
  :: ASimMeta RSimMeta ;
;

NULLNAME FctrMeta
::
  ASimMeta RFctrMeta
;

**********************************************************************
* Desc:		Calculate common integer factor
* Stack:	( Meta --> Meta FALSE | Meta %n TRUE )
* Notes:	RCanno is *NOT* called
*		This is intended for extracting an integer coefficient
*		from sums or products.
**********************************************************************
NULLNAME CommonFactor
::
  metaDUP CKSymbN			( Meta sym )
  DUP PVars				( Meta sym vars )	
  SWAPOVER				( Meta vars sym vars )
  A2R					( Meta vars Pn Pd )
  SWAP PPZ				( Meta vars Pd Pn' Z )
  DupZIsOne? case2drop 2DROPFALSE	( --> Meta FALSE )
  4UNROLL SWAPROT			( Meta Z Pn' Pd vars )
  R2A					( Meta Z sym' )
  TWO psh NDROP DROP			( Z sym' )
  syminner get1 Z>R TRUE		( Meta' %n TRUE )
;

**********************************************************************
**********************************************************************
*	Do Functions With Simplifications
**********************************************************************
**********************************************************************

**********************************************************************
* Desc:		Simplify regular non-symbolic object
**********************************************************************
NULLNAME SimpOb
::
  DUPTYPECMP? NOTcase ONE	( return as is if non-complex )

  C%>% { xi x* x+ } INNERCOMP #2+

;

**********************************************************************
* Desc:		+ - * / functions
* Notes:
**********************************************************************
NULLNAME Simp+
NULLNAME Simp-
NULLNAME Simp*
NULLNAME Simp/
::
  #1-SWAP OVER#2+UNROLL			( fcn Meta )
  splitonearg				( fcn Meta1 Meta2 )
  ASimMeta psh ASimMeta pshtop&		( fcn Meta' )
  get1 SWAP#1+				( Meta'' )
;

**********************************************************************
* Desc:		NEG function
* Notes:
**********************************************************************
NULLNAME SimpNeg
::
  pullDROP ASimMeta complsign
;
**********************************************************************
* Desc:		INV function
* Notes:	inv(i)      = -i
*		inv(inv(x)) = x
**********************************************************************
NULLNAME SimpInv
::
  pullDROP ASimMeta

  AEQ1stcase xi		onlyputopCHS
  AEQ1stcase xINV	pullDROP
  onlyputopINV
;
**********************************************************************
* Desc:		SQ function
* Notes:	sq(sqrt(x)) = x
*		sq(i) = -1
*		sq(cos(x))  = 1-sq(sin(x))
*		sq(tan(x))  = sq(sin(x)/cos(x))
*		sq(cosh(x)) = 1+sq(sinh(x))
*		sq(tanh(x)) = sq(sinh(x)/cosh(x))
*		sq(x^y)     = x^(2*y)
**********************************************************************
NULLNAME SimpSq
::

  pullDROP ASimMeta

  CODE
	GOSUB	FcnDispatch:
	FCNABS	xSQRT,pullDROP	
	FCNABS	xi,NDROP-1ONE
	FCNREL	x^,simpsq^
	FCNREL	xCOS,simpsqcos
	FCNREL	xCOSH,simpsqcosh
	FCNREL	xTAN,simpsqtan
	FCNREL	xTANH,simpsqtanh
	FCNEND
  ENDCODE
  COLA_EVAL

  putop: xSQ
;

LABEL simpsq^
	:: %2 ' x* 2SWAP #2+ SimpPow ;
LABEL simpsqcos
	:: swapop: xSIN putop2: xSQ xNEG putop2: %1 x+ ;
LABEL simpsqcosh
	:: swapop: xSINH putop: xSQ putop2: %1 x+ ;
LABEL simpsqtan
	:: metaDUP swapop: xSIN psh swapop: xCOS top& putop2: x/ xSQ ;
LABEL simpsqtanh
	:: metaDUP swapop: xSINH psh swapop: xCOSH top& putop2: x/ xSQ ;


**********************************************************************
* Desc:		^ function
* Notes:	1^x = 1
*		e^x = exp(x)			if x nonreal
*		(-x)^even = x^even
*		sqrt(x)^even = x^(even/2)
*		i^integer = { 1 i -1 -i } MOD 4
*		exp(x)^y = exp(y*x)		if y nonreal
*		alog(x)^y = alog(y*x)		if x nonreal
**********************************************************************
NULLNAME SimpPow
::
  pullDROP splitonearg		( base exp )
  SimpMeta			( base exp )

  OVER REALcase SimpPowN

  psh SimpMeta			( exp base )
  AEQ1stcase %1
	:: psh NDROP ;
  AEQ1stcase xCONSTANTe
	:: 2DROP putop: xEXP ;
  AEQ1stcase xEXP
	:: pullDROP top& putop2: x* xEXP SimpExp ;
  AEQ1stcase xALOG
	:: pullDROP top& putop2: x* xALOG SimpALog ;

  pshtop&			( base&exp )
  putop: x^
;

NULLNAME SimpPowN
  ::
	( Simplify [-expr]^even and sqrt[x]^even )
	OVER %2 %MOD %0= IT
	:: 4PICK EQ: xNEG IT
	   :: 4ROLLDROP ROT #1-UNROT ;		( drop neg )
	   4PICK EQ: xSQRT NOT?SEMI
	   4ROLLDROP ROT #1-UNROT		( drop sqrt )
	   SWAP %2 %/ SWAP			( N = N/2 )
	;

	( Simplify simple powers )

	OVER %0= case2drop NDROP1ONE
	OVER %1 %= case2DROP
	OVER %-1 %= casedrop :: SWAP#1+ SimpInv ;
	OVER %2 %= casedrop :: SWAP#1+ SimpSq ;
	OVER %-2 %= casedrop :: SWAP#1+ SimpSq onlyputopINV SimpInv ;

	( Simplify sqrt[x]^odd )
	4PICK EQ: xSQRT case
	::
	  DROP 1LAMBIND				( Meta&sqrt )
	  metaDUP pullDROP			( Meta&sqrt Meta )
	  1GETLAM %ABS %1- %2 %/ SWAP#1+	( Meta&sqrt Meta&pow )
	  top& putop2: x^ x*			( Meta' )
	  1GETABND %0< IT onlyputopINV		( Meta'' )
	  SimpMeta
	;

	( Simplify i^n )

	OVER %FP %0= 5PICK EQ: xi ANDcase
	:: DROP UNROT2DROP %4 %MOD COERCE #1+
	   { %1 xi %-1 DOSYMB xi xNEG [;] }
	   SWAP NTHCOMPDROP syminner
	;

        psh ASimMeta pshtop& ' x^ SWAP#1+
  ;

**********************************************************************
* Desc:		SQRT function
* Notes:	sqrt(sq(x)) = x
*		sqrt(x^2) = x
*		sqrt(xy) = sqrt(x)sqrt(y)
*		sqrt(x/y) = sqrt(x)/sqrt(y)
*		sqrt(-x) = sqrt(x)i
*		sqrt(root) = a+b*sqrt(x)
*		sqrt(x^y) = sqrt(x)*x^(y-1)/2		y odd
*		sqrt(x^y) = x^(y/2)			y even
**********************************************************************
LABEL SimpSqrt
::
  pullDROP

  CODE
resimpsqrt
	GOSUBL	FcnDispatch:
	FCNABS	xSQ,pullDROP
	FCNREL	x*,simpsqrt*
	FCNREL	x/,simpsqrt/
	FCNREL	x^,simpsqrt^
	FCNREL	xNEG,simpsqrtneg
	FCNEND
  ENDCODE
  COLA_EVAL

* Note: FormRoot? before Fctr avoids NEG problem

  SimpMeta				( Simplify )
  FormRoot? case			( Check root form )
	TakeRoot
  RFctrMeta				( Factorize )
  CODE					( And retry simplifications )
	GOTO	resimpsqrt
  ENDCODE
  COLA_EVAL

  AEQ1stcase %0 NOP			( sqrt[0] = 0 )
  AEQ1stcase %1 NOP			( sqrt[1] = 1 )
  AEQ1stcase %-1 :: swapop: xi ;	( sqrt[-1] = i )

  putop: xSQRT
;


LABEL simpsqrtneg
	:: swapop: xSQRT timesi Simp* ;
LABEL simpsqrt*
	:: plDRPpZparg putoptwice: xSQRT pshtop& onlyputop* Simp* ;
LABEL simpsqrt/
	:: plDRPpZparg putoptwice: xSQRT pshtop& putop: x/ Simp/ ;
LABEL simpsqrt^
	::
	  pullDROP splitonearg		( base pow )
	  OVER TYPEREAL? ITE
	    :: OVER %FP %0<> ;		( true if non-integer )
	    TRUE			( true if non-real )
	  case
	  ::
	    SimpMeta psh SimpMeta pshtop& putop2: x^ xSQRT
	  ;

	  DROPDUP %2 %MOD %0=		( base %n even? )
	  case
	   ::
		%2 %/ SWAP#1+
		putop: x^ SimpPow
	   ;

	  1LAMBIND				( save %n )
	  metaDUP putop: xSQRT pshtop&
	  1GETABND
	  %1- %2 %/ SWAP#1+
	  putop2: x^ x* Simp*
	;


**********************************************************************
* Desc:		EXP function
* Notes:	exp(0)    = 1
*		exp(1)    = e
*		exp(-1)   = inv(e)
*		exp(real) = e^real
*		exp(ln(x)) = x
*		exp(-x)   = inv(exp(x))
*		exp(x+y)  = exp(x)exp(y)
*		exp(x-y)  = exp(x)/exp(y)
*		exp(xy)   = exp(y)^x		if x is real
*		exp(pi*i) = -1
**********************************************************************

NULLNAME SimpExp
::
  pullDROP
  CODE
resimpexp
	GOSUBL	FcnDispatch:
	FCNABS	xLN,pullDROP
	FCNREL	xNEG,simpexpneg
	FCNREL	x+,simpexp+
	FCNREL	x-,simpexp-
	FCNEND
  ENDCODE
  COLA_EVAL

  SimpMeta				( Meta )

  OVER REALcase
  ::
	DROP			( % )
	DUP%0= casedrop		:: %1 ONE ;

	DUP %0> SWAP %ABS	( sflag |x| )
	::
	  %1=case	:: ' xEXP TWO ;
	  %1 ' xEXP ' x^ 4ROLLSWAP FOUR
	;
	get1 ?SEMI putop: xINV
  ;

  CommonFactor				( Meta FALSE | Meta' %n TRUE )
  case
  ::
	SWAP#1+ putop2: xEXP x^		( Meta&n&exp&^ )
	4ROLL UNROT			( Meta&exp&n&^ )
	SimpPow
  ;

  CODE
	GOTO	resimpexp
  ENDCODE
  COLA_EVAL

  MEQ*case
	::
	   metaDUP CKSymbN DOSYMB xPI xi x* SEMI
	   EQUAL RAD? ANDcase NDROP-1ONE

	   plDRPpZparg		( y x )
	   OVER REALcase
	   :: psh putop: xEXP pshtop& putop: x^ SimpPow ;
	   pshtop& putop2: x* xEXP
	;

  putop: xEXP
;

LABEL simpexpneg
	:: swapop: xEXP onlyputopINV SimpInv ;
LABEL simpexp+
	:: plDRPpZparg putoptwice: xEXP pshtop& onlyputop* Simp* ;
LABEL simpexp-
	:: plDRPpZparg putoptwice: xEXP pshtop& putop: x/ Simp/ ;

**********************************************************************
* Desc:		ALOG function
* Notes:	alog(integer) = integer
*		alog(log(x)) = x
*		alog(-x) = inv(alog(x))
*		alog(x+y) = alog(x)alog(y)
*		alog(x-y) = alog(x)/alog(y)
*		alog(xy)  = alog(y)^x		if x is real
**********************************************************************
NULLNAME SimpALog
::
  pullDROP
  CODE
resimpalog
	GOSUBL	FcnDispatch:
	FCNABS	xLOG,pullDROP
	FCNREL	xNEG,simpalogneg
	FCNREL	x+,simpalog+
	FCNREL	x-,simpalog-
	FCNEND
  ENDCODE
  COLA_EVAL

  SimpMeta

  OVER REALcase
  :: DROPDUP %0>= OVER %FP %0= ANDcase :: %ALOG ONE ;
     %10 SWAP' x^ THREE
  ;

  CommonFactor				( Meta FALSE | Meta' %n TRUE )
  case
  ::
	SWAP#1+ putop2: xALOG x^	( Meta&n&alog&^ )
	4ROLL UNROT			( Meta&alog&n&^ )
	SimpPow
  ;

  CODE
	GOTO	resimpalog
  ENDCODE
  COLA_EVAL

  MEQ*case
	:: plDRPpZparg		( y x )
	   OVER REALcase
	   :: psh putop: xALOG pshtop& putop: x^ SimpPow ;
	   pshtop& putop2: x* xALOG
	;

  putop: xALOG
;


LABEL simpalogneg
	:: swapop: xALOG onlyputopINV SimpInv ;
LABEL simpalog+
	:: plDRPpZparg putoptwice: xALOG pshtop& onlyputop* Simp* ;
LABEL simpalog-
	:: plDRPpZparg putoptwice: xALOG pshtop& putop: x/ Simp/ ;

**********************************************************************
* Desc:		LN function
* Notes:	ln(1)       = 0
*		ln(-1)      = pi*i
*		ln(e)       = 1
*		ln(i)       = pi*i/2
*		ln(exp(x))  = x
*		ln(xy)      = ln(x)+ln(y)
*		ln(x/y)     = ln(x)-ln(y)
*		ln(x^y)     = y ln(x)
*		ln(inv(x))  = -ln(x)
*		ln(sqrt(x)) = ln(x)/2
**********************************************************************
LABEL SimpLn
::
  pullDROP

  CODE
resimpln
	GOSUBL	FcnDispatch:
	FCNABS	xCONSTANTe,NDROP1ONE
	FCNABS	xEXP,pullDROP
	FCNREL	xi,simplni
	FCNREL	x*,simpln*
	FCNREL	x/,simpln/
	FCNREL	x^,simpln^
	FCNREL	xINV,simplninv
	FCNREL	xSQ,simplnsq
	FCNREL	xSQRT,simplnsqrt
	FCNEND
  ENDCODE
  COLA_EVAL

  FctrMeta

  CODE
	GOTO	resimpln
  ENDCODE
  COLA_EVAL

* Should try factoring the simplified expression now

  OVER REALcase
  :: DROP
     %1=case		:: DROP %0 ONE ;
     %-1=case		:: DROP { xPI xi x* } INNERCOMP ;
     ' xLN TWO
  ;

  putop: xLN
;

LABEL simplni
	:: 2DROP { %1 %2 x/ xPI x* xi x* } INNERCOMP ;
LABEL simpln*
	:: plDRPpZparg putoptwice: xLN pshtop& onlyputop+ Simp+ ;
LABEL simpln/
	:: plDRPpZparg putoptwice: xLN pshtop& onlyputop- Simp- ;
LABEL simpln^
	:: plDRPpZparg putop: xLN top& onlyputop* Simp* ;
LABEL simplninv
	:: pullDROP putop2: xLN xNEG SimpNeg ;
LABEL simplnsq
	:: swapop: xLN putop2: %2 x* Simp* ;
LABEL simplnsqrt
	:: swapop: xLN putop2: %2 x/ Simp/ ;

**********************************************************************
* Desc:		LOG function
* Notes:	log(1)       = 0
*		log(alog(x)) = x
*		log(xy)      = log(x)+log(y)
*		log(x/y)     = log(x)-log(y)
*		log(x^y)     = y log(x)
*		log(inv(x))  = -log(x)
*		log(sqrt(x)) = log(x)/2
**********************************************************************
LABEL SimpLog
::
  pullDROP

  CODE
resimplog
	GOSUBL	FcnDispatch:
	FCNABS	xALOG,pullDROP
	FCNREL	x*,simplog*
	FCNREL	x/,simplog/
	FCNREL	x^,simplog^
	FCNREL	xINV,simploginv
	FCNREL	xSQ,simplogsq
	FCNREL	xSQRT,simplogsqrt
	FCNEND
  ENDCODE
  COLA_EVAL

  FctrMeta

  CODE
	GOTO	resimplog
  ENDCODE
  COLA_EVAL

  OVER REALcase
  :: DROPDUP %LOG DUP %FP j%0=case :: SWAPDROP ONE ;
     DROP' xLOG TWO
  ;

  putop: xLOG
;


LABEL simplog*
	:: plDRPpZparg putoptwice: xLOG pshtop& onlyputop+ Simp+ ;
LABEL simplog/
	:: plDRPpZparg putoptwice: xLOG pshtop& onlyputop- Simp- ;
LABEL simplog^
	:: plDRPpZparg putop: xLOG top& onlyputop* Simp* ;
LABEL simploginv
	:: pullDROP putop2: xLOG xNEG SimpNeg ;
LABEL simplogsq
	:: swapop: xLOG putop2: %2 x* Simp* ;
LABEL simplogsqrt
	:: swapop: xLOG putop2: %2 x/ Simp/ ;

**********************************************************************
* Desc:		SIN function
* Notes:	sin(asin(x)) = x
*		sin(acos(x)) = sqrt(1-x^2)
*		sin(atan(x)) = x/sqrt(1+x^2)
*		sin(-x)      = -sin(x)
**********************************************************************
LABEL SimpSin
::
   SimpMeta1 FormPi?			( Meta FALSE / #a TRUE )
   case
   ::
      {
	%0
	DOSYMB %2 xSQRT xINV SEMI
	%1
	DOSYMB %2 xSQRT xINV SEMI
	%0
	DOSYMB %2 xSQRT xNEG xINV SEMI
	%-1
	DOSYMB %2 xSQRT xNEG xINV SEMI
      }
      SWAP#1+ NTHCOMPDROP syminner
   ;

   :: M-1stcasechs TRUE FALSE ;
   OVER#2+UNROLL			( sflag Meta )
   ::
     AEQ1stcase xASIN
	pullDROP
     AEQ1stcase xACOS
	:: swapop: xSQ %1 psh1top& onlyputop- putop: xSQRT ;
     AEQ1stcase xATAN
	:: pullDROP metaDUP %1 psh1top& putop2: xSQ x+ top& putop2: xSQRT x/ ;
     putop: xSIN
   ;
   get1 NOT?SEMI onlyputopCHS
;
**********************************************************************
* Desc:		COS function
* Notes:	cos(acos(x)) = x
*		cos(asin(x)) = sqrt(1-x^2)
*		cos(atan(x)) = 1/sqrt(1+x^2)
*		cos(-x)      = cos(x)
**********************************************************************
LABEL SimpCos
::
  SimpMeta1 FormPi?			( Meta FALSE / #a TRUE )
  case
  ::
     {
	%1
	DOSYMB %2 xSQRT xINV SEMI
	%0
	DOSYMB %2 xSQRT xNEG xINV SEMI
	%-1
	DOSYMB %2 xSQRT xNEG xINV SEMI
	%0
	DOSYMB %2 xSQRT xINV SEMI
     }
     SWAP#1+ NTHCOMPDROP syminner
  ;

  :: M-1stcasechs NOP ;
  AEQ1stcase xACOS
	pullDROP
  AEQ1stcase xASIN
	:: swapop: xSQ %1 psh1top& onlyputop- putop: xSQRT ;
  AEQ1stcase xATAN
	:: swapop: xSQ %1 psh1top& onlyputop+ putop2: xSQRT xINV ;
  putop: xCOS
;
**********************************************************************
* Desc:		TAN function
* Notes:	tan(atan(x)) = x
*		tan(asin(x)) = x/sqrt(1-x^2)
*		tan(acos(x)) = sqrt(1-x^2)/x
*		tan(-x)      = -tan(x)
**********************************************************************
LABEL SimpTan
::
   SimpMeta1 FormPi?			( Meta FALSE / #a TRUE )
   case
   ::
      FOUR #/ DROP			( Modulo 4 instead of 8 )
      {
	%0
	%1
	DOSYMB %1 %2 x/ xPI x* xTAN SEMI
	%-1
      }
      SWAP#1+ NTHCOMPDROP syminner
   ;

   :: M-1stcasechs TRUE FALSE ;		( sflag Meta )
   OVER#2+UNROLL
   ::
     AEQ1stcase xATAN
	pullDROP
     AEQ1stcase xASIN
	:: pullDROP metaDUP %1 psh1top& putop2: xSQ x- top& putop2: xSQRT x/ ;
     AEQ1stcase xACOS
	:: pullDROP metaDUP %1 psh1top& putop2: xSQ x- putop: xSQRT
	   pshtop& putop: x/
	;
     putop: xTAN
   ;
   get1 NOT?SEMI onlyputopCHS
;
**********************************************************************
* Desc:		ASIN function
* Notes:	asin(0) = 0
**********************************************************************
LABEL SimpASin
::
   SimpMeta1
   OVER j%0=case NOP
   putop: xASIN
;
**********************************************************************
* Desc:		ACOS function
* Notes:
**********************************************************************
LABEL SimpACos
::
   SimpMeta1
   putop: xACOS
;
**********************************************************************
* Desc:		ATAN function
* Notes:	atan(0) = 0
**********************************************************************
LABEL SimpATan
::
   SimpMeta1
   OVER j%0=case NOP
   putop: xATAN
;
**********************************************************************
* Desc:		SINH function
* Notes:	sinh(0) = 0
*		sinh(asinh(x)) = x
*		sinh(acosh(x)) = a mess
*		sinh(atanh(x)) = x/sqrt(1-x^2)
**********************************************************************
LABEL SimpSinh
::
   SimpMeta1
   AEQ1stcase xASINH
	pullDROP
   AEQ1stcase xATANH
	:: pullDROP metaDUP %1 psh1top& putop2: xSQ x- top& putop2: xSQRT x/ ;
   OVER j%0=case
	NOP
   putop: xSINH
;
**********************************************************************
* Desc:		COSH function
* Notes:	cosh(0) = 1
*		cosh(acosh(x)) = x
*		cosh(asinh(x)) = sqrt(1+x^2)
*		cosh(atanh(x)) = 1/sqrt(1-x^2)
**********************************************************************
LABEL SimpCosh
::
   SimpMeta1
   AEQ1stcase xACOSH
	pullDROP
   AEQ1stcase xASINH
	:: swapop: xSQ %1 psh1top& putop2: x+ xSQRT ;
   AEQ1stcase xATANH
	:: swapop: xSQ %1 psh1top& onlyputop- putop2: xSQRT xINV ;
   OVER j%0=case
	:: %1 ROTDROPSWAP ;
   putop: xCOSH
;
**********************************************************************
* Desc:		TANH function
* Notes:	tanh(0) = 0
*		tanh(atanh(x)) = x
*		tanh(asinh(x)) = -ix/sqrt(1+x^2)
*		tanh(acosh(x)) = a mess
**********************************************************************
LABEL SimpTanh
::
   SimpMeta1
   AEQ1stcase xATANH
	pullDROP
   AEQ1stcase xASINH
	:: pullDROP metaDUP %1 psh1top& putop2: xSQ x+ top& putop2: xSQRT x/
	   timesi onlyputopCHS
	;
   OVER j%0=case
	NOP   
   putop: xTANH
;
**********************************************************************
* Desc:		ASINH function
* Notes:	asinh(0) = 0
**********************************************************************
LABEL SimpASinh
::
   SimpMeta1
   OVER j%0=case NOP
   putop: xASINH
;
**********************************************************************
* Desc:		ACOSH function
* Notes:
**********************************************************************
LABEL SimpACosh
::
   SimpMeta1
   putop: xACOSH
;
**********************************************************************
* Desc:		ATANH function
* Notes:	atanh(0) = 0
**********************************************************************
LABEL SimpATanh
::
   SimpMeta1
   OVER j%0=case NOP
   putop: xATANH
;
**********************************************************************
* Desc:		ABS function
* Notes:	abs(abs(x)) = abs(x)
*		abs(re(x))  = re(x)
*		abs(im(x))  = im(x)
*		abs(pi)     = pi
*		abs(e)      = e
*		abs(i)      = 1
*		abs(-x)     = abs(x)
**********************************************************************
LABEL SimpAbs
::
  SimpMeta1
  OVER REALcase		:: SWAP %ABS SWAP ;

  CODE
	GOSUBL	FcnDispatch:
	FCNABS	xABS,NOP
	FCNABS	xRE,NOP
	FCNABS	xIM,NOP
	FCNABS	xPI,NOP
	FCNABS	xCONSTANTe,NOP
	FCNABS	xi,NDROP1ONE
	FCNREL	xNEG,simpabsneg
	FCNEND
  ENDCODE
  COLA_EVAL
  putop: xABS
;

LABEL simpabsneg
	:: swapop: xABS ;

**********************************************************************
* Desc:		RE function
* Notes:	re(re(x))   = re(x)
*		re(im(x))   = im(x)
*		re(conj(x)) = re(x)
*		re(abs(x))  = abs(x)
*		re(pi)      = pi
*		re(e)       = e
*		re(i)       = 0
*		re(-x)      = -re(x)
*		re(x+y)     = re(x)+re(y)
*		re(x-y)     = re(x)-re(y)
**********************************************************************
LABEL SimpRe
::
  SimpMeta1
  OVER REALcase		NOP
  CODE
	GOSUBL	FcnDispatch:
	FCNABS	xRE,NOP
	FCNABS	xIM,NOP
	FCNREL	xCONJ,simpreconj
	FCNABS	xABS,NOP
	FCNABS	xPI,NOP
	FCNABS	xCONSTANTe,NOP
	FCNABS	xi,NDROP0ONE
	FCNREL	xNEG,simpreneg
	FCNREL	x+,simpre+
	FCNREL	x-,simpre-
	FCNEND
  ENDCODE
  COLA_EVAL
  putop: xRE
;

LABEL simpreconj
	:: swapop: xRE ;
LABEL simpreneg
	:: swapop: xRE onlyputopCHS ;
LABEL simpre+
	:: plDRPpZparg putoptwice: xRE pshtop& onlyputop+ ;
LABEL simpre-
	:: plDRPpZparg putoptwice: xRE pshtop& onlyputop- ;

**********************************************************************
* Desc:		IM function
* Notes:	im(im(x))   = 0
*		im(re(x))   = 0
*		im(conj(x)) = -im(x)
*		im(abs(x))  = 0
*		im(pi)      = 0
*		im(e)       = 0
*		im(i)       = 1
*		im(-x)      = -im(x)
*		im(x+y)     = im(x)+im(y)
*		im(x-y)     = im(x)-im(y)
**********************************************************************
LABEL SimpIm
::
  SimpMeta1
  OVER REALcase		NDROP0ONE

  CODE
	GOSUBL	FcnDispatch:
	FCNABS	xRE,NDROP0ONE
	FCNABS	xIM,NDROP0ONE
	FCNREL	xCONJ,simpimconj
	FCNABS	xABS,NDROP0ONE
	FCNABS	xPI,NDROP0ONE
	FCNABS	xCONSTANTe,NDROP0ONE
	FCNABS	xi,NDROP1ONE
	FCNREL	xNEG,simpimneg
	FCNREL	x+,simpim+
	FCNREL	x-,simpim-
	FCNEND
  ENDCODE
  COLA_EVAL
  putop: xIM
;

LABEL simpimconj
LABEL simpimneg
	:: swapop: xIM onlyputopCHS ;
LABEL simpim+
	:: plDRPpZparg putoptwice: xIM pshtop& onlyputop+ ;
LABEL simpim-
	:: plDRPpZparg putoptwice: xIM pshtop& onlyputop- ;

**********************************************************************
* Desc:		CONJ function
* Notes:	conj(conj(x)) = x
*		conj(re(x))   = re(x)
*		conj(im(x))   = im(x)
*		conj(abs(x))  = abs(x)
*		conj(pi)      = pi
*		conj(e)       = e
*		conj(i)       = -i
*		conj(-x)      = -conj(x)
*		conj(x+y)     = conj(x)+conj(y)
*		conj(x-y)     = conj(x)-conj(y)
**********************************************************************l
LABEL SimpConj
::
  SimpMeta1
  OVER REALcase		NOP

  CODE
	GOSUBL	FcnDispatch:
	FCNABS	xCONJ,pullDROP
	FCNABS	xRE,NOP
	FCNABS	xIM,NOP
	FCNABS	xABS,NOP
	FCNABS	xPI,NOP
	FCNABS	xCONSTANTe,NOP
	FCNABS	xi,onlyputopCHS
	FCNREL	xNEG,simpconjneg
	FCNREL	x+,simpconj+
	FCNREL	x-,simpconj-
	FCNEND
  ENDCODE
  COLA_EVAL
  putop: xCONJ
;

LABEL simpconjneg
	:: swapop: xCONJ onlyputopCHS ;
LABEL simpconj+
	:: plDRPpZparg putoptwice: xCONJ pshtop& onlyputop+ ;
LABEL simpconj-
	:: plDRPpZparg putoptwice: xCONJ pshtop& onlyputop- ;

**********************************************************************
* Desc:		Take Meta square root of a root form
* Stack:	( %b %x %a --> Meta )
* Notes:
*    __________
*   /       _	        _		D = B/2C
*  / A + B /X  = C + D /X	==>			    _________
*					C^2 = A/2 +- 1/2 * / A^2-B^2X
*
**********************************************************************
NULLNAME TakeRoot
::					( b x a )

* First calculate the argument as float for result checks

  OVER %SQRT 4PICK %* OVER %+		( b x a float )

* Normalize a,b,x so that we calculate with |float|

  DUP 5UNROLL %0< IT			( float b x a )
	:: %CHS ROT %CHS UNROT ;	( float -b x -a )

  DUPDUP %* 4PICK DUP %* 4PICK %* %-	( float b x a a^2-b^2x )

* Now fail if the A^2-B^2X root is negative

  DUP %0< ITE
	DROPFALSE

* Else try calculating c, only one of the numbers can be an integer

	::
	  %SQRT				( float b x a root )
	  2DUP %- %2 %/ %SQRT		( float b x a root |c1| )
	  SWAP3PICK %+ %2 %/ %SQRT	( float b x a |c1| |c2| )
          OVER %FP %0= casedrptru
	  SWAPDROPDUP %FP %0= caseTRUE
	  DROPFALSE
	;

  ( float  b x a [c TRUE / FALSE )

* If failed then output original square root

  NOTcase
	::				( float b x a )
	  ' xSQRT 'x* ROT ' x+ SIX		
	  SYMBN RSim syminner
	  putop: xSQRT			( float Meta )
	  get1 %0< NOT?SEMI
	  timesi
	;

* Calculate matching d
					( float b x a c )
  SWAPDROP				( float b x c )
  ROTOVER				( float x c b c )		
  %/ %2 %/ UNROT			( float d x c )

* Check if the signs are correct by checking c+d*sqrt(x) > 0

  2DUPSWAP %SQRT 5PICK %* %+		( float d x c c+d*sqrt[x] )
  %0< IT :: %CHS ROT %CHS UNROT ;	( Diff sign - fix c,d signs )

* Then build a Meta object from them
					( float d x c )
  ' xSQRT 'x* ROT ' x+ SIX		( float d x SQRT * c + 6 )
  RSimMeta				( put to standard form )

* Then add *i if the original input was negative

  get1 %0< NOT?SEMI			( --> Meta )
  timesi				( --> Meta*i )

;

**********************************************************************
* Desc:		Extract possible rational number
* Stack:	( Meta --> Meta FALSE )
*		( Meta --> %a %b TRUE )		( b nonegative )
* Notes:
*
*	Rational form:	'a/b' where symbols are real
*
*	Possibilities are:
*
*		%a #1
*		%a xNEG #2
*		%a %b x/ #3
*		%a %b x/ xNEG #4
**********************************************************************
NULLNAME FormRat?
CODE
		GOSBVL	=SAVPTR

		GOSBVL	=POP#

		A=A-1	A
		GOC	notratform
		A=A-1	A
		GOC	ratform1
		A=A-1	A
		GOC	ratform2
		A=A-1	A
		GOC	ratform3
		A=A-1	A
		GOC	ratform4
notratform	GOVLNG	=GPPushFLoop

ratform1	GOSUB	Expect%
ratform/1	R1=A	W
		A=0	W		Load %1 into A[W]
		A=A+1	S
		ASR	W
		R2=A	W
		GOTO	pushratform

ratform2	GOSUB	ExpectNeg
		GOSUB	Expect%
		SETDEC
		A=-A-1	S		Negate it
		SETHEX
		GOTO	ratform/1	And return 1 as b

ratform3	GOSUB	Expect/
		GOSUB	Expect%
		R2=A	W		b
		GOSUB	Expect%
		R1=A	W		a
		GOTO	pushratform

ratform4	GOSUB	ExpectNeg
		GOSUB	Expect/
		GOSUB	Expect%
		R2=A	W		b
		GOSUB	Expect%
		SETDEC
		A=-A-1	S
		SETHEX
		R1=A	W		a

* Do NDROP - push R1[W] and R2[W] as real - push TRUE
pushratform	GOSUB	NDrop
		A=R2	W		Normalize b to nonnegative
		?A=0	S
		GOYES	pushratnow
		SETDEC
		A=-A-1	S		-b
		R2=A	W
		A=R1	W
		A=-A-1	S		-a
		R1=A	W
pushratnow	A=R1	W
		GOSUB	SavptrPush%
		A=R2	W
		GOSUB	SavptrPush%
		GOVLNG	=PushTLoop
ENDCODE

**********************************************************************
* Desc:		Extract possible root sum
* Stack:	( Meta --> Meta FALSE )
*		( Meta --> %a %x %b TRUE )
* Notes:
*
*	Root form: 'a*SQRT(x)+b' where symbols are real
*
*	Possibilities after simplification are:
*
*		a x SQRT *     b + #6
*		a x SQRT * NEG b + #7
*		a x SQRT *     b - #6
*		a x SQRT * NEG b - #7
*
**********************************************************************
NULLNAME FormRoot?

CODE
sSQRT6	EQU 0		Flag to indicate #6, not #7
sSQRT+	EQU 1		Flag to indicate +, not -

		CLRST			Clear flags

		GOSBVL	=SAVPTR
		GOSBVL	=POP#

		C=0	A
		LC(1)	7
		?A=C	A
		GOYES	formrootszok	Size is 7
		ST=1	sSQRT6		Assume 6
		C=C-1	A
		?A=C	A
		GOYES	formrootszok	It was - continue
notformroot	GOVLNG	=GPPushFLoop	No match - return [Meta FALSE]

formrootszok	A=DAT1	A		Expect + or -
		D1=D1+	5
		LC(5)	=x-		#1AD09
		?A=C	A
		GOYES	formrootsum
		ST=1	sSQRT+		Not minus - assume +
		LC(3)	=x+		#1AB67
		?A#C	 A
		GOYES	notformroot	Was neither - fail

formrootsum	GOSUB	Expect%		Expect real
		R1=A			R1[W] = b
		?ST=1	sSQRT6		No NEG expected if size was 6
		GOYES	formrootnegok
		GOSUB	ExpectNeg
formrootnegok	GOSUB	Expect*
		GOSUB	ExpectSqrt
		GOSUB	Expect%
		R2=A			R2[W] = x
		GOSUB	Expect%
		R3=A			R3[W] = a

* Passed the test - return results with correct signs

		GOSUB	NDrop		Do NDROP
	
		A=R3			a
		SETDEC
		?ST=1	sSQRT6		Negate if there was a NEG
		GOYES	formrootapsh
		A=-A-1	S
formrootapsh	GOSUB	SavptrPush%

		A=R2			x is the right sign
		GOSUB	SavptrPush%

		A=R1			b is negative if there was a -
		SETDEC
		?ST=1	sSQRT+
		GOYES	formrootbpsh
		A=-A-1	S
formrootbpsh	GOSUB	SavptrPush%

		GOVLNG	=PushTLoop	==> ( %a %x %b TRUE )

SavptrPush%	GOSBVL	=SAVPTR
		GOVLNG	=PUSH%

* Expect various functions on stack - if no match then GPPushFLoop

*	Expect*Pi	GOSUB	Expect*
*	ExpectPi	LC(5)	=xPI
*			GOTO	expectc
ExpectNeg	LC(5)	=xNEG
		GOTO	expectc
Expect+		LC(5)	=x+
		GOTO	expectc
Expect-		LC(5)	=x-
		GOTO	expectc
Expect*		LC(5)	=x*
		GOTO	expectc
Expect/		LC(5)	=x/
		GOTO	expectc
ExpectSqrt	LC(5)	=xSQRT
expectc		A=DAT1	A
		D1=D1+	5
		?A=C	A
		RTNYES
		GONC	expectfail	GPPushFLoop

* Expect real on stack - if none then GPPushFLoop - else return % in A[W]

Expect%		C=DAT1	A		->ob
		D1=D1+	5		skip it
		D0=C			->ob
		A=DAT0	A
		LC(5)	=DOREAL
		?A#C	A
		GOYES	expectfail	Not real - abort with FALSE
		D0=D0+	5
		A=DAT0	W		A[W] = %
		RTN
expectfail	GOTO	notformroot	GPPushFLoop

* Do NDROP on data stack

NDrop		GOSBVL	=GETPTR
		GOSBVL	=POP#
		C=A	A
		D=D+C	A		Fix available memory
		AD1EX			Fix data stack pointer
		A=A+C	A
		C=C+C	A
		C=C+C	A
		A=A+C	A
		AD1EX
		RTNCC
ENDCODE

**********************************************************************
* Desc:		Extract possible fraction of PI
* Stack:	( Meta --> Meta FALSE )
*		( Meta --> #a TRUE )
* Algorithm:
*		If Meta == 0 then return #0
*		If Meta has no xPI then return FALSE
*		Else divide by PI and see if numeric coefficient remains
*		If not then return FALSE
*		If not multiple of 1/4 then return FALSE
*		Else return denominator times 4 modulo 8 and TRUE
*
*		    0 --> #0	   pi --> #4	and multiples
*		 pi/4 --> #1	5pi/4 --> #5
*		 pi/2 --> #2	3pi/2 --> #6
*		3pi/4 --> #3	7pi/4 --> #7
*
* Notes:	The required matching and modulo arithmetic is
*		very inconvenient in assembly, thus the RPL.
**********************************************************************

NULLNAME FormPi?
::
   RAD? NOTcaseFALSE			( Abort if not in radian mode )

   OVER %0= case2drop			( Test %0 special case )
	:: ZERO TRUE ;			( --> #0 TRUE )

   CODE
		GOSBVL	=SAVPTR		* Test if xPI exists in Meta *
		GOSBVL	=POP#
		B=A	A		B[A] = counter
		LC(5)	=xPI
-		B=B-1	A
		GOC	formnopi	tested all obs - no PI
		A=DAT1	A
		D1=D1+	5
		?A#C	A
		GOYES	-		Test until match or done
formnopi	GOVLNG	=GPPushT/FLp	TRUE if no PI
   ENDCODE
   caseFALSE

   metaDUP putop2: xPI x/ SYMBN		( Meta Sym )

   DUP PVars				( Meta Sym vars )
   DUPLENCOMP #1<>			( Test if more vars than PI )
   case2drpfls				( --> Meta FALSE )
   A2R RCanno				( Meta Pn Pd )

   DUPTYPEHSTR? 3PICK TYPEHSTR? AND	( Test for rational number )
   NOTcase2drop FALSE			( --> Meta FALSE )

   SWAP HXS 2 40 QMul SWAP RCanno	( Meta Pn*4 Pd )
   ZIsOne?				( Test for multiple of 1/4 )
   NOTcsdrpfls				( --> Meta FALSE )

   HXS 1 0 HXS 2 80 ModAdd		( Take modulo 8 )
   HXS>#				( Meta #a )
   OVER#2+UNROLL NDROP TRUE		( --> #a TRUE )
;

**********************************************************************
**********************************************************************
*		Merge functions in simplified expressions
**********************************************************************
**********************************************************************


**********************************************************************
* Desc:		Merge logarithms, exponentials etc
* Stack:	( sym --> sym' )
* Notes:	The symbolic is assumed to be in simplified form.
*		This means that no special case checks for special
*		function arguments are needed. Also some assumptions
*		on the relative order of some functions can be made.
**********************************************************************

NULLNAME MergeSym
:: syminner MergeMeta CKSymbN ;

**********************************************************************
* Desc:		Merge logarithms, square roots etc
* Stack:	( Meta --> Meta'
* Notes:
*
*	inv(exp(x))		= exp(-x)
*	inv(alog(x))		= alog(-x)
*
*	ln(x)+ln(y)		= ln(x*y)
*	a+ln(x)+ln(y)		= a+ln(x*y)
*	a-ln(x)+ln(y)		= a+ln(y/x)
*	ln(x)-ln(y)		= ln(x/y)
*	a+ln(x)-ln(y)		= a+ln(x/y)
*	a-ln(x)-ln(y)		= a-ln(x*y)
*	a*ln(b)			= ln(a^b)		a,b real
*	a*exp(x)*exp(y)		= a*exp(x+y)		+ alog
*
*	  a			  -a*i
*	-----			= -----
*	b*i*c			   b*c
*
*	exp(x)^y		= exp(x*y)
*
*	a*exp(x)*b		  a*exp(x-y)*b
*	----------		= ------------
*	c*exp(y)*d		      c*d
*
*	a*sqrt(x)*sqrt(y)	= a*sqrt(x*y)
*
*	i*sqrt(x)		= sqrt(-x)
*
*	a*sqrt(x)*b		  a*sqrt(x/y)*b
*	-----------		= -------------
*	c*sqrt(y)*d		     c*d
*
*	  a*x*b			  a*sqrt(x)*b
*	-----------		= -----------
*	c*sqrt(x)*d		     c*d
*
*	a*sin(x)*b		  a*tan(x)*b		+ sinh
*	----------		= ----------
*	c*cos(x)*d		     c*d
*
*	a*sin(x)*b		  a*cos(x)*b
*	----------		= ----------
*	c*tan(x)*d		     c*d
*
*	a*tan(x)*b		     a*b
*	----------		= ----------
*	c*sin(x)*d		  c*cos(x)*d
*
*	a*cos(x)*b*tan(x)	= a*b*sin(x)
*
*	Trivial cases arising from fractions:
*	^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
*
*	a/nothing		= a
*	a/neg			= -a
*	n*a/number		= n/number*a
*	a/number		= 1/number*a
*
*	Missing:
*	^^^^^^^^
*	a*log(x)*b + a*log(y)*b	= a*log(xy)*b
*	Always move sqrt(x) to nominator (+ sum variants)
*
*	Problems:
*	^^^^^^^^^
*	can't handle sin(x)^2/cos(x)^2 etc
*
**********************************************************************
NULLNAME MergeMeta
::
   OVER TYPESYMB? case
   :: #1-SWAP INNERCOMP top& MergeMeta ;

   DUP#1= ?SEMI

   MEQ+case	Merge+
   MEQ-case	Merge-
   MEQ*case	Merge*
   MEQ/case	Merge/
   MEQ^case	Merge^
   MEQINVcase	MergeInv

* Unknown function remains - merge its arguments and rebuild

   #1-SWAP OVER#2+UNROLL		( fcn Meta )
   pshzer				( fcn #0 Meta )

   BEGIN
	splitonearg			( fcn Meta_done Meta' Meta_arg )
	MergeMeta
	roll2ND top& psh		( fcn Meta_done' Meta' )
	DUP#0=
   UNTIL
   DROP

   get1 SWAP#1+				( Meta&fcn )
   veryunsymin syminner			( Rebuild properly )
;

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*		Merge functions
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

*---------------------------------------------------------------------
* Forms (INV)	:	inv(exp(x))	= exp(-x)
*			inv(alog(x))	= alog(-x)
*			inv(a*i)	= -i/a
*---------------------------------------------------------------------
NULLNAME MergeInv
::
  pullDROP MergeMeta
  AEQ1stcase xEXP	:: pullDROP complsign putop: xEXP ;
  AEQ1stcase xALOG	:: pullDROP complsign putop: xALOG ;
* Try following later
*  ' xi HasFcn? ITE
*	:: Extract onlyputopCHS psh MergeFix* ;
*	FALSE
*  caseDROP
  putop: xINV
;

*---------------------------------------------------------------------
* Forms (+)	:	ln(x)+ln(y)	= ln(x*y)
*---------------------------------------------------------------------
NULLNAME Merge+
::
   MergeTwice				( Merge arguments separately )
   AEQ1stcase xLN	Merge+Log
   AEQ1stcase xLOG	Merge+Log

*  Should add test for	a*log(x)*b + a*log(y)*b

   top& onlyputop+
;

*---------------------------------------------------------------------
* Forms (-)	:	ln(x)-ln(y)	= ln(x/y)
*---------------------------------------------------------------------
NULLNAME Merge-
::
   MergeTwice				( Merge arguments separately )
   AEQ1stcase xLN	Merge-Log
   AEQ1stcase xLOG	Merge-Log

*  Should add test for	a*log(x)*b - a*log(y)*b

   top& onlyputop-
;

*---------------------------------------------------------------------
* Forms (*)	:	exp(x)*exp(y)	= exp(x+y)
*			sqrt(x)*sqrt(y)	= sqrt(x*y)
*			a*ln(b)		= ln(b^a)
*			cos(x)*tan(x)	= sin(x)
*---------------------------------------------------------------------
NULLNAME Merge*
::
   MergeTwice				( Merge arguments separately )
   AEQ1stcase xEXP	Merge*Exp
   AEQ1stcase xALOG	Merge*Exp
   AEQ1stcase xSQRT	Merge*Sqrt
   AEQ1stcase xLN	Merge*Log
   AEQ1stcase xLOG	Merge*Log
   AEQ1stcase xTAN
	:: ' xCOS ' xTAN BothHaveSame? NOTcase
		:: top& onlyputop* ;
	   notcertain			( !!! )
	   Extract2 NDROP swapop: xSIN
	   get1 DROP			( Drop #0 left by TAN )
	   get1 DUP#0=csDROP		( Done if COS left #0 )
	   #+ onlyputop* ReSort		( Else just merge and sort )
	;	      
   top& onlyputop*
;

*---------------------------------------------------------------------
* Forms (^)	:	exp(x)^y	= exp(x*y)
*---------------------------------------------------------------------
NULLNAME Merge^
::
  MergeTwice				( Merge arguments separately )
  psh					( exp base )
  AEQ1stcase xEXP	Merge^Exp
  AEQ1stcase xALOG	Merge^Exp
  pshtop& putop: x^
;

*---------------------------------------------------------------------
* Forms (/)	:	exp(x)/exp(y)	= exp(x-y)
*			sqrt(x)/sqrt(y)	= sqrt(x/y)
*			sin(x)/cos(x)	= tan(x)
*			sin(x)/tan(x)	= cos(x)
*			tan(x)/sin(x)	= 1/cos(x)
*			x/sqrt(x)	= sqrt(x)
*---------------------------------------------------------------------
NULLNAME Merge/
::
  MergeTwice				( Merge arguments separately )

* Note that /i test must be first so that the size=1 end tests won't
* cause it to be missed.

  ' xi HasFcn? ITE
	:: Extract onlyputopCHS Merge*Back ;
	FALSE
  caseDROP

* EXP and ALOG are unique due to MergeTwice

  ' xEXP BothHaveFcn? ITE
	:: Extract2 MergeTo- Merge*Back ;
	FALSE
  caseDROP

  ' xALOG BothHaveFcn? ITE
	:: Extract2 MergeTo- Merge*Back ;
	FALSE
  caseDROP

  FALSE ' xSQRT BothHaveSame? ITE
	:: Extract2 psh NDROP
	   roll2ND MergeMult MergeMeta psh MergeFix*		( !!! )
	;
	FALSE
  caseDROP

  ' xSQRT BothHaveFcn? ITE
	:: Extract2 MergeTo/ MergeMeta Merge*Back ;		( !!! )
	FALSE
  caseDROP

  BEGIN
	' xSIN ' xCOS BothHaveSame? ITE
	:: Extract2 NDROP swapop: xTAN Merge*Back notcertain ;
	FalseTrue
  UNTIL
  ?SEMI

  BEGIN
	' xSINH ' xCOSH BothHaveSame? ITE
	:: Extract2 NDROP swapop: xTANH Merge*Back notcertain ;
	FalseTrue
  UNTIL
  ?SEMI

  BEGIN
	' xSIN ' xTAN BothHaveSame? ITE
	:: Extract2 NDROP swapop: xCOS Merge*Back notcertain ;
	FalseTrue
  UNTIL
  ?SEMI

  BEGIN
	' xSINH ' xTANH BothHaveSame? ITE
	:: Extract2 NDROP swapop: xCOSH Merge*Back notcertain ;
	FalseTrue
  UNTIL
  ?SEMI

  BEGIN
	' xTAN ' xSIN BothHaveSame? ITE
	:: Extract2 NDROP swapop: xCOS Merge/Back notcertain ;
	FalseTrue
  UNTIL
  ?SEMI

  BEGIN
	' xTANH ' xSINH BothHaveSame? ITE
	:: Extract2 NDROP swapop: xCOSH Merge/Back notcertain ;
	FalseTrue
  UNTIL
  ?SEMI

  top& putop: x/
;

* This subroutine is used to multiply an expression back into the denominator
* of a fraction with special Extract special case checks.
* ( A B expr --> A B*expr + triviality checks )

NULLNAME Merge/Back
::
  psh MergeMult				( Multiply expr into B )
  MergeFix/				( Handle nominator )
;

* Check for trivial nominators		( [] Meta --> Meta' )

NULLNAME MergeFix/
::
  psh
  DUP#0=csedrp					( Handle [] )
	:: %1 ONE pshtop& putop: x/ TrueTrue ;
  DUP#1= NOTcase				( Handle [regular] )
	:: psh FALSE ;
  MEQCHScase					( Handle [NEG] )
	:: swapop: %-1 pshtop& putop: x/ TrueTrue ;
  psh TrueTrue					( Handle [ob] )
;

* This subroutine is used to multiply an expression back into the nominator
* of a fraction with special Extract special case checks.
* ( A B expr --> A*expr B  + triviality checks )

NULLNAME Merge*Back
::
  roll2ND MergeMult psh MergeFix*
;

* Check for trivial denominators	( Meta [] --> Meta' )

NULLNAME MergeFix*
::
  DUP#0=csedrp					( Handle [] )
	TrueTrue
  DUP#1= NOTcaseFALSE				( Handle [regular] )

  MEQCHScase					( Handle [NEG] )
	:: 2DROP M-1stcasechs TrueTrue onlyputopCHS TrueTrue ;

  OVER TYPEREAL? NOTcase			( Handle [nonreal] )
	:: top& putop: x/ TrueTrue ;

* Now handle division by real number by putting the coefficient in front.
* First we need to check if the leading factor is a real number
* (I opted out, this is the simplest way to do it)

  DROP SWAP#1+ putop: x/		( Meta/n )
  ReSort				( Meta' )
  TrueTrue				( done - no more denominator )
;

* This utility handles multiplication ob Meta objects when Extract
* special cases are possible in Meta2.
* ( Meta1 Meta2 --> Meta )

NULLNAME MergeMult
::
  DUP#0=csDROP				( Handle [] )
  DUP#1= 3PICK EQ: xNEG ANDcase		( Handle [NEG] )
	:: 2DROP onlyputopCHS ;
  top& onlyputop* ReSort		( Handle regular Meta2 )
;

* This utility handles further trigonometric simplifications if
* any are possible.

*	NULLNAME MergeTrig
*	::
*	  caseTRUE				( Denominator vanished )
*	  top& putop: x/ RSimMeta		( Simplify trigs )
*	  MEQ/case
*		:: pullDROP splitonearg FALSE ;	( And restore split form )
*	  TrueTrue				( Simplified / away! )
*	;

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*		Merge logarithm functions
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

* Merge a+log(b)
NULLNAME Merge+Log
::
  OVER MEQopscase				( ln[x] + ln[y] )
	:: MergeTo* MergeMeta ;				( !!! )

  EQops+ case					( a+ln[x] + ln[y] )
	::
	  psh pullDROP splitonearg pullDROP		( M M1 M2 )
	  ROTUntop& onlyputop* ROTSWAP MergeReal	( M1 M' )
	  MergeMeta					( !!! )
	  top& onlyputop+
	;

  EQops- case					( a-ln[x] + ln[y] )
	::
	  pullDROP psh plDRPpZparg			( M M2 M1 )
	  && psh putop: x/ ROTSWAP			( M1 M' )
	  MergeMeta					( !!! )
	  top& onlyputop+
	;

  top& onlyputop+
;

* Merge a-log(b)
NULLNAME Merge-Log
::
  OVER MEQopscase				( ln[x] - ln[y] )
	:: MergeTo/ MergeMeta ;				( !!! )

  EQops+ case					( a+ln[x] - ln[y] )
	::
	  psh pullDROP splitonearg pullDROP		( M M1 M2 )
	  ROTUntop& putop: x/ ROTSWAP			( M1 M' )
	  MergeMeta					( !!! )
	  top& onlyputop+
	;

  EQops- case					( a-ln[x] - ln[y] )
	::
	  psh pullDROP splitonearg pullDROP		( M M1 M2 )
	  ROTUntop& onlyputop* ROTSWAP MergeReal	( M1 M' )
	  MergeMeta					( !!! )
	  top& onlyputop-
	;

  top& onlyputop-
;

* Merge a*log(b) for a,b both real
NULLNAME Merge*Log
::
  DUP #3+PICK TYPEREAL?
  4PICK TYPEREAL? ANDcase			( %a #1 %b log #2 )
	:: DROP ROTDROP UNROTSWAP		( log %b %a )
	   DUP %0> case
	   :: %^ SWAP TWO ;			( --> %x log #2 )
	   %ABS %^ ' xINV ROT THREE		( --> %x inv log #3 )
	;

  top& onlyputop*
;

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*		Merge exponential functions
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

* Merge a*exp(b)
NULLNAME Merge*Exp
::
  OVER MEQopscase				( exp[x] * exp[y] )
	MergeTo+

  EQops* case					( a*exp[x] * exp[y] )
	:: psh pullDROP splitonearg pullDROP		( M M1 M2 )
	   ROTUntop& onlyputop+ ROTSWAP MergeReal	( M1 M' )
	   top& onlyputop*				( M'' )
	;

  top& onlyputop*
;

* Merge exp(a)^b.
NULLNAME Merge^Exp
::
  top& onlyputop* ROTSWAP MergeReal MergeMeta		( !!! )
;

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*		Merge square roots
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

* Merge a*sqrt(b)
NULLNAME Merge*Sqrt
::
  OVER MEQopscase				( sqrt[x] * sqrt[y] )
	:: MergeTo* MergeMeta ;				( !!! )

  EQops* case					( a*sqrt[x] * sqrt[y] )
	:: psh pullDROP splitonearg pullDROP		( M M1 M2 )
	   ROTUntop& onlyputop* ROTSWAP MergeReal	( M1 M' )
	   MergeMeta					( !!! )
	   top& onlyputop*				( M'' )
	;

  top& onlyputop*
;

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
*		Merge utilities
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 

* Split binary function and merge arguments
NULLNAME MergeTwice
:: plDRPpZparg MergeMeta psh MergeMeta ;

* Merge dual function into function of *
NULLNAME MergeTo*
:: onlyputop* MergeProd MergeReal ;

* Merge dual function into function of /
NULLNAME MergeTo/
:: putop: x/ MergeProd ;

* Merge dual function into function of +
NULLNAME MergeTo+
:: onlyputop+ MergeSum MergeReal ;

* Merge dual function into function of -
NULLNAME MergeTo-
:: onlyputop- MergeSum MergeReal ;

* ( Meta1&fcn Meta2&fcn&op --> Meta1&Meta2&op&fcn reordered )
NULLNAME MergeProd
::
  psh pullDROP				( Meta2&fcn&op Meta1 )
  pshtop&				( Meta1&Meta2&fcn&op )
  #1-ROT				( Meta1&Meta2&op fcn )
  OVER#2+UNROLL				( fcn Meta1&Meta2&op )
  shift<-A				( fcn Meta )
  get1 SWAP#1+				( Meta&fcn )
;

* Same but with proper canonical sort

NULLNAME MergeSum
::
  psh pullDROP
  pshtop&
  #1-ROT
  OVER#2+UNROLL
  ReSort
  get1 SWAP#1+
;

* ( %a %b +-* fcn #4 --> %x fcn #2 )
NULLNAME MergeReal
::
  4PICK TYPEREAL? NOT?SEMI
  5PICK TYPEREAL? NOT?SEMI
  DROP 4UNROLL					( fcn %a %b +-* )
  EvalNoCK					( fcn %x )
  SWAP TWO					( %x fcn #2 )
;

* Canonical sort for Meta object
NULLNAME ReSort
::
  DUP#1= ?SEMI
  SYMBN
  DUP PVars SWAPOVER A2R ROT R2A
  syminner
;

**********************************************************************
* Desc:		Special Meta matching case word
* Stack:	( Meta1 Meta2 --> Meta1 Meta2 )
* Notes:
*		COLA if
*			Meta1 = ..&fcn&*
*			Meta2 = ..&fcn
**********************************************************************
NULLNAME EQops*
CODE
		LC(5)	=x*		Expect * in Meta1
		GOTO	INTOopscase

ENDCODE
**********************************************************************
* Desc:		Special Meta matching case word
* Stack:	( Meta1 Meta2 --> Meta1 Meta2 )
* Notes:
*		COLA if
*			Meta1 = ..&fcn&+
*			Meta2 = ..&fcn
**********************************************************************
NULLNAME EQops+
CODE
		LC(5)	=x+		Expect + in Meta1
		GOTO	INTOopscase
ENDCODE
**********************************************************************
* Desc:		Special Meta matching case word
* Stack:	( Meta1 Meta2 --> Meta1 Meta2 )
* Notes:
*		COLA if
*			Meta1 = ..&fcn&-
*			Meta2 = ..&fcn
**********************************************************************
NULLNAME EQops-
CODE
		LC(5)	=x-		Expect - in Meta1

INTOopscase	RSTK=C			Save test function
		GOSBVL	=SAVPTR
		GOSUBL	SkipMeta	A[A] = ->Meta2	D1 = ->Meta1
		D0=A
		D0=D0+	5
		D1=D1+	10
		A=DAT1	A		fcn in Meta1
		C=DAT0	A		fcn in Meta2
		?A#C	A
		GOYES	opscaseskip	No match - push FALSE
		D1=D1-	5		topfcn in Meta1
		A=DAT1	A
		C=RSTK
		?A#C	A
		GOYES	opscaseskip	No match - push FALSE
opscasecola	LC(5)	=TRUE		(=COLA)
		GONC	+
opscaseskip	LC(5)	=FALSE		(=SKIP)
+		GOVLNG	=GETPTREVALC

ENDCODE

**********************************************************************
* Desc:		A replacement for the internal shift<-A which
*		- does some unsuitable changes
*		- calls covered ROMPTRs (would error)
* Stack:	( Meta --> Meta' )
* Notes:	The purpose is to reorder the meta so that
*		unnecessary parenthesis are not shown
*		Really should try to get rid of this.
**********************************************************************

NULLNAME shift<-A
::
  BEGIN
    CODE
		D1=D1+	5
		A=DAT1	10		Stack1 and Stack2
		C=A	W
		D1=D1-	5
		LC(N)	10		**
		CON(5)	=x*
		CON(5)	=x*
		?A=C	W
		GOYES	m<-A
		LC(N)	10		 ++
		CON(5)	=x+
		CON(5)	=x+
		?A=C	W
		GOYES	m<-A
		LC(5)	=x-		+-
		?A=C	W
		GOYES	m<-A
		LC(N)	10		--
		CON(5)	=x-
		CON(5)	=x-
		?A=C	A
		GOYES	m<-A--
		LC(5)	=x+		-+
		?A=C	W
		GOYES	m<-A-+
		GOVLNG	=PushFLoop	No match - false

m<-A-+		LC(5)	=x-		Swap op1 into a -
		GOC	+
m<-A--		LC(5)	=x+		Swap op1 into a +
+		D1=D1+	10
		DAT1=C	A
		D1=D1-	10
m<-A		GOVLNG	=PushTLoop
    ENDCODE
    ITE
	:: gen<-A FALSE ;
	TRUE
  UNTIL
;
**********************************************************************
* Desc:		Test if 2 Meta objects have a factor with the
*		same given topmost function.
* Stack:	( Meta1 Meta2 fcn --> Meta1 Meta2 FALSE )
*		( Meta1 Meta2 fcn --> Meta1 Meta2 #pos1 #pos2 TRUE )
**********************************************************************
NULLNAME BothHaveFcn?
CODE
		GOSBVL	=PopASavptr
		R4=A	A			R4[A] = fcn

		GOSUB	MetaHasFcn?
		GONC	hasntfcn		Doesn't have it - fail
		R3=A	A			R3[A] = pos2

		GOSUB	SkipMeta
		GOSUB	MetaHasFcn?
		GONC	hasntfcn		Doesn't have it - fail
		R0=A	A			R0[A] = pos1
		C=R3	A
		R1=C	A			R1[A] = pos2
		GOSBVL	=PUSH2#
		GOVLNG	=PushTLoop		( .. #pos1 #pos2 TRUE )

*---------------------------------------------------------------------
* Skip meta in D1, leaving old value in A[A]
*---------------------------------------------------------------------

SkipMeta	A=DAT1	A		->#
		AD1EX
		D1=D1+	5
		C=DAT1	A		N
		D1=A			->old D1
		A=A+C	A
		C=C+C	A
		C=C+C	A
		A=A+C	A
		AD1EX			A[A] = ->Meta
		D1=D1+	5		D1 = ->Metatail
		RTN
ENDCODE

**********************************************************************
* Desc:		Test if Meta object has a factor with the
*		given topmost function.
* Stack:	( Meta fcn --> Meta #pos TRUE )
*		( Meta fcn --> Meta FALSE )
* Notes:	The Meta object is assumed to look like one of
*			[A (NEG)]
*			[A B * C * .. Z * (NEG)]
*		Examples:
*			[A fcn]		--> pos = 0
*			[A fcn NEG]	--> pos = 1
*			[A B fcn *]	--> pos = 1
*			[A fcn B * NEG]	--> pos = 3
*
**********************************************************************
NULLNAME HasFcn?
CODE
		GOSBVL	=PopASavptr
		R4=A	A			R4[A] = fcn

		GOSUB	MetaHasFcn?
		GONC	hasntfcn
		R0=A	A			R0[A] = pos
		GOVLNG	=Push#TLoop		( .. #pos TRUE )
hasntfcn	GOVLNG	=GPPushFLoop		( .. FALSE )

*---------------------------------------------------------------------
* Test if Meta object has factor with given topmost function
* Entry:	D1    = ->Meta
*		R4[A] = fcn
* Output:	CC:	No such factor
*		CS:	A[A] = position of function
*			D1   = ->fcn
* Special:	If fcn = 0 then all factors match
*
*		** =scanahead notes **
*	
*		Input:	R0[A] = stack level (it just increments it)
*			R1[A] = expressions to skip
*			D1    = ->meta position
*		Output: R0[A] = updated stack level
*			D1    = ->new meta position
*---------------------------------------------------------------------

sHASMORE	EQU 10			* scanahead uses [4,5]

MetaHasFcn?	A=0	A
		R0=A	A		R0[A] = level

		CD1EX
		RSTK=C			Save ->Meta
		CD1EX
		D1=D1+	5		Skip #size


		A=DAT1	A		Skip possible topmost negate
		LC(5)	=xNEG		(no other possible location for it!)
		?A#C	A
		GOYES	+
		D1=D1+	5
		A=R0	A
		A=A+1	A		level++
		R0=A
+

hasfcnloop	ST=0	sHASMORE	Assume last factor now
		A=DAT1	A		See if it really is
		LC(5)	=x*
		?A#C	A
		GOYES	+
		ST=1	sHASMORE	Flag has more
		D1=D1+	5		And skip x*
		A=R0
		A=A+1	A		level++
		R0=A
+
		A=DAT1	A		Now test factor
		C=R4	A		against given function
		?C=0	A
		GOYES	hasfcnYES	Special case!
		?A=C	A
		GOYES	hasfcnYES	Match!

		?ST=1	sHASMORE
		GOYES	hasfcncont	Has more factors - continue

hasfcnYES	C=RSTK
		CD1EX			Restore ->Meta
		A=R0	A		A[A] = level
		RTN			Preserve CRY for flag

hasfcncont	C=0	A
		LC(1)	1		Skip this factor only
		R1=C	A
		GOSBVL	=scanahead
		GOTO	hasfcnloop	And try again

ENDCODE

**********************************************************************
* Desc:		Test if 2 Meta objects have factors with given
*		topmost functions but with equal contents.
* Stack:	( Meta1 Meta2 fcn1 fcn2 --> Meta1 Meta2 FALSE )
*		( Meta1 Meta2 fcn1 fcn2 --> Meta1 Meta2 #pos1 #pos2 TRUE )
* Special:	fcn=FALSE means there is no topmost function
* Notes:	The idea is to search for cases like
*
*			a*sin(x)*b	  a*tan(x)*b
*			----------	= ----------
*			c*cos(x)*d	     c*d
*
* Algorithm:	10 Scan Meta2 for fcn2
*		20 If not found then fail
*		30 Scan Meta1 for fcn1
*		40 If not found then fail
*		50 Compare Metas - if match then success
*		60 Find next Meta1 fcn1
*		70 If found then 50
*		80 Find next Meta2 fcn2
*		90 Jump to 20
*
**********************************************************************
NULLNAME BothHaveSame?
CODE
sHASONE		EQU 11
sHASTOP1	EQU 9
sHASTOP2	EQU 8

		A=DAT1	A		fcn2
		D1=D1+	5
		D=D+1	A
		LC(5)	=FALSE
		ST=1	sHASTOP2
		?A#C	A
		GOYES	+
		ST=0	sHASTOP2
		A=0	A
+		R4=A	A		R4[A] = fcn2
		GOSBVL	=PopASavptr
		LC(5)	=FALSE
		ST=1	sHASTOP1
		?A#C	A
		GOYES	+
		ST=0	sHASTOP1
		A=0	A
+		R3=A	A		R3[A] = fcn1

* First scan for fcn2 in Meta2

ScanFcn2	GOSUB	MetaHasFcn?
		GOC	+		Has one - continue
		GOTO	BothSameFail	Hasn't - fail

* Save position for continuing if this factor has no match in Meta1

+		R2=C	A		->fcn2

* Count the size of the subexpression in Meta2

		D1=C
		C=0	A
		R0=C	A		levels=0
		LC(1)	1
		R1=C	A		skip=1
		GOSBVL	=scanahead	R0[A] = levels
		C=R0
		RSTK=C			RSTK=levels

* Prepare Meta1 scanning loop

		GOSBVL	=D1=DSKTOP
		GOSUB	SkipMeta	->Meta2
		AR3EX			
		AR4EX			R4[A] = fcn1
		AR3EX			R3[A] = fcn2

* A loop to scan Meta1 for a match

		ST=0	sHASONE		Flag no match in Meta1 yet
ScanFcn1	GOSUB	MetaHasFcn?
		GONC	ScanFcn2Next	Has no more fcn1 - cont in Meta2
		ST=1	sHASONE		Flag had atleast one match
		RSTK=C			Save ->fcn1
		D1=C
		C=0	A
		R0=C	A		levels=0
		LC(1)	1
		R1=C	A		skip=1
		GOSBVL	=scanahead	R0[A] = levels in subexpression 2
		C=RSTK
		D1=C			->fcn1
		A=R0			levels1
		C=RSTK			levels2
		RSTK=C
		?ST=0	sHASTOP1	Adjust sizes if
		GOYES	+		topmost functions exist
		A=A-1	A
+		?ST=0	sHASTOP2
		GOYES	+
		C=C-1	A
+		?A=C	A		If same adjusted size
		GOYES	ScanCmp		then compare elements
		?ST=0	sHASMORE	Else if Meta1 scanned already
		GOYES	ScanFcn2Next	Then - search new match in Meta2
		A=R0	A		Else keep going in Meta1
		CD1EX			Skip Meta1 subexpression
		C=C+A	A
		A=A+A	A
		A=A+A	A
		C=C+A	A		+ 5*levels1
		D1=C
		D1=D1-	5		"Fix" #n skipping in MetaHasFcn?
		GONC	ScanFcn1	And loop

* Meta1 had no more matches - continue Meta2 scanning
* If Meta1 had no matches at all then fail

ScanFcn2Next	?ST=0	sHASONE		If Meta1 had no fcn1
		GOYES	BothSameFail	Then fail completely
ScanFcn2Cont	AR3EX			
		AR4EX			R4[A] = fcn2
		AR3EX			R3[A] = fcn1
		A=R2			->fcn2
		D1=A			Check if Meta2 has more factors..
		D1=D1-	5
		A=DAT1	A		.. possible only if fcn2 was
		LC(5)	=x*		.. preceded by *
		?A#C	A
		GOYES	BothSameFail	No * - fail completely
		C=RSTK			levels in Meta1 subexpression
		AD1EX
		A=A+C	A		skip them
		C=C+C	A
		C=C+C	A
		A=A+C	A
		D1=A
		GOTO	ScanFcn2	And loop to search for fcn2 again

BothSameFail	GOVLNG	=GPPushFLoop


* Meta1 and Meta2 subexpressions have same number of elements - compare them
* A[A] = number of elements to compare
* If fcn1 = 0 then no topmost function
* If fcn2 = 0 then no topmost function

ScanCmp		R0=A	A		# of elements to compare (-1)
		A=R2	A		->fcn2
		D0=A

		?ST=0	sHASTOP1	Adjust comparison start points
		GOYES	+
		D1=D1+	5
+		?ST=0	sHASTOP2
		GOYES	++
		D0=D0+	5
		GONC	++		And enter the loop

scancmploop	D0=D0+	5		skip fcn2
		D1=D1+	5		skip fcn1
++		A=R0	A
		A=A-1	A
		R0=A
		GOC	scancmpmatch	All matched!
		A=DAT0	A
		AD0EX
		GOSBVL	=ASLW5
		A=DAT1	A
		AD1EX
		R1=A			R1[A]=D1  R1[A1]=D0
		GOSUB	callEQUAL?
		A=R1
		D1=A
		GOC	scancmpfail	Different object - back to loops
		GOSBVL	=ASRW5
		D0=A
		GOTO	scancmploop	Loop until compared all

* Not equal subexpression - jump back to the loops

scancmpfail	?ST=1	sHASMORE
		GOYES	+
		GOTO	ScanFcn2Cont	No more in Meta1 - continue in Meta2
+		C=R0	A		levels left to compare in subexpr
		A=A+C	A
		C=C+C	A
		C=C+C	A
		A=A+C	A
		D1=A			->subexpression tail in Meta1
		GOTO	ScanFcn1	Jump back in & find next fcn1

* Found a match - return it

scancmpmatch	C=RSTK			levels in subexpression
		A=C	A
		C=C+C	A
		C=C+C	A
		C=C+A	A		5*levels
		AD1EX
		A=A-C	A
		R0=A			R0[A] = ->fcn1
		AD0EX
		A=A-C	A
		R1=A			R1[A] = ->fcn2
		GOSBVL	=D1=DSKTOP
		GOSUB	SkipMeta	D1 = ->Meta1	A[A] = ->Meta2

		C=R1	A		->fcn2
		C=C-A	A
		GOSBVL	=DIV5
		?ST=0	sHASTOP2
		GOYES	+
		C=C-1	A
+		R1=C			#pos2

		C=R0	A		->fcn1
		AD1EX
		C=C-A	A
		GOSBVL	=DIV5
		?ST=0	sHASTOP1
		GOYES	+
		C=C-1	A
+		R0=C			#pos1

		GOSBVL	=PUSH2#
		GOVLNG	=PushTLoop

* Too long for GOSUBL

callEQUAL?	A=PC
		LC(5)	(EQUAL?)-(*)
		A=A+C	A
		PC=A

ENDCODE

**********************************************************************
* Desc:		Extract factor from 2 expressions
* Stack:	( Meta1 Meta2 #pos1 #pos2 --> Meta1' Meta2' Sub1 Sub2 )
**********************************************************************
NULLNAME Extract2
::
  ' NULLLAM DUPTWO DOBIND		( Meta1 Meta2 )
  psh 2GETLAM Extract			( Meta2 Rem1 Sub1 )
  roll2ND 1GETABND Extract		( Rem1 Sub1 Rem2 Sub2 )
  argswap				( Rem1 Rem2 Sub1 Sub2 )
;

**********************************************************************
* Desc:		Extract factor from expression
* Stack:	( Meta #pos --> Meta' Meta_pos )
* Notes:	This extracts the full factor from the given position
*		The remaining Meta object is also stripped of the
*		matching * function, but nothing else.
*
*		Possible special cases:
*
*			--> #0			( Full term extracted )
*			--> xNEG #1		( Only NEG remains )
*
**********************************************************************
NULLNAME Extract
::
  ( Drop the associated * if there is one )
  CODE
		GOSBVL	=SAVPTR
		GOSBVL	=POP#
		R4=A	A		R4[A] = pos
		B=0	A		stklevel = 0
		D1=D1+	5		Skip #size
		A=DAT1	A		Skip leading NEG if there is on
		LC(5)	=xNEG
		?A#C	A
		GOYES	+
		D1=D1+	5
		B=B+1	A		stklevel++
+		A=B	A
		R0=A	A		R0[A] = stklevel

		C=R4			Handle [A NEG] and [A] special cases
		?A>=C	A
		GOYES	no*extract	

--		A=R0	A		A[A] = stklevel
		R2=A	A		Save position of *
		A=A+1	A
		R0=A	A
		C=R4	A		C[A] = pos
		?A>=C	A
		GOYES	yes*extract	Found the matching *
		D1=D1+	5		Skip *
		C=0	A
		LC(1)	1
		R1=C	A		Skip 1
		GOSBVL	=scanahead
		A=DAT1	A
		LC(5)	=x*		See if we have a * or whether
		?A=C	A		we found the last subexpression
		GOYES	--
yes*extract	A=R2	A
		A=A+CON	A,3		Increase for ROLLDROP
		R0=A	A
		GOVLNG	=Push#TLoop
no*extract	GOVLNG	=GPPushFLoop
  ENDCODE
  IT :: ROLLDROP #1- SWAP#1-SWAP ;

  ( Split into 2 parts, part 1 ends with subexpression )

  2DUP #- ROTDROP OVER#2+UNROLL		( Part1&Sub Part2 )

  ( Extract subexpression from Part1 )
  psh splitonearg				( Part2 Part1 Sub )

  ( And merge Part1 and Part2 )
  argswap&&					( Part1&Part2 Sub )
;
**********************************************************************
