**********************************************************************
*		ALG48 Unsupported Entries & DEFINEs
**********************************************************************

DEFINE AutoSimFlag FIVE
DEFINE VerboseFlag ONE

ASSEMBLE
sDUMMYCOEFF	EQU 8	   * Global coeff=1 for Distribute subroutine
sMODULAR	EQU 9      * Global modular mode flag
sGARB		EQU 10     * Global GC-done flag
sTRASH		EQU 11     * Global trash topmost tempob flag

* User functions in the order IsV>V? would put them (address sort)

=x=             EQU #1A8D8 *
=xNEG		EQU #1A995 *
=xABS		EQU #1AA1F *
=xCONJ		EQU #1AA6E *
=xPI		EQU #1AABD *
=xCONSTANTe	EQU #1AB23 *
=xi		EQU #1AB45 *
=xINV   	EQU #1B278 *
=xSQRT		EQU #1B374 *
=xSQ		EQU #1B426 *
=xSIN		EQU #1B4AC *
=xCOS		EQU #1B505 *
=xTAN		EQU #1B55E *
=xSINH		EQU #1B5B7 *
=xCOSH		EQU #1B606 *
=xTANH		EQU #1B655 *
=xASIN		EQU #1B6A4 *
=xACOS		EQU #1B72F *
=xATAN		EQU #1B79C *
=xASINH		EQU #1B7EB *
=xACOSH		EQU #1B830 *
=xATANH		EQU #1B8A2 *
=xEXP		EQU #1B905 *
=xLN		EQU #1B94F *
=xLOG		EQU #1B9C6 *
=xALOG		EQU #1BA3D *
=xMOD		EQU #1BE4D *
=xRE		EQU #1C7CA *
=xIM		EQU #1C819 *

* Machine language entries

=aTEMPTOP	EQU #179EA * Hook
=aDOLPENV	EQU #04E73 * Hook
=aATTNFLG	EQU #4226C * Hook

=OverWrALoop	EQU #03678 * ML
=OverWrR0Lp	EQU #03B65 * ML
=WIPEOUT	EQU #0675C * ML
=STUFF		EQU #0675F * ML
=GETPTREVALC	EQU #15C77 * ML
=recover	EQU #166A2 * ML
=GPPushR0Lp	EQU #307D2 * ML
=GPPushALp	EQU #307D5 * ML
=hex>%		EQU #54371 * ML
=scanahead	EQU #5F821 * ML
=IDIV		EQU #65807 * ML

* Miscellaneous

=2SKIP		EQU #0715C *
=EXITLOOP	EQU #07321 *	Stop DO-LOOP
=RROLL		EQU #14F2A *	Return stack ROLL
='EvalNoCK:	EQU #18F6A *	EvalNoCK on the following program
=ONESYMBN	EQU #5E661 *

* Meta handling

=gen<-A		EQU #5CA0F *	( Meta --> Meta' )
=timesi		EQU #5DD83 *	( Meta --> Meta&i&* )
=syminner	EQU #5E067 *	( ob --> meta )
=unsyminner	EQU #5E085 *	( meta --> ob )
=syminnertwo	EQU #5E30C *	( ob1 ob2 --> 1 2 )
=&&		EQU #5E3C0 *	( 1 2 3 --> 1&2 3 )
=metaDUP	EQU #5E35C *	( 1 --> 1 1 )
=argswap&&	EQU #5E843 *	( 1 2 3 --> 2&1 3 ) 
=argswap	EQU #5E857 *	( 1 2 3 --> 2 1 3 )
=numargs	EQU #5E889 *	( Meta fcn --> Meta fcn #arguments )
=enumargs	EQU #5E8DE *	( fcn --> fcn #arguments )
=splitonearg	EQU #5EAC2 *	( [expr1 expr2] --> [expr1] [expr2] )
=pullDROP	EQU #5EAF4 *	( Meta&ob --> Meta )
=roll2ND	EQU #5EB58 *	( 1 2 3 --> 2 3 1 )
=verysyminner	EQU #5F2A3 *	( ob --> Meta )
=veryunsymin	EQU #5F2EE *	( Meta --> ob )
=pick1		EQU #5FC24 *	( ob Meta --> ob Meta ob )

=complsign	EQU #5BBE5 *	( :: M-1stcasechs NOP putop: xNEG ; )
=onlyputop-	EQU #5BC67 *	( Meta --> Meta&- )
=onlyputop+	EQU #5CD02 *	( Meta --> Meta&+ )
=onlyputop*	EQU #5CD16 *	( Meta --> Meta&* )
=onlyputopCHS	EQU #5CD2A *	( Meta --> Meta&NEG )
=onlyputopINV	EQU #5CD3E *	( Meta --> Meta&INV )
=putop:		EQU #5E51C *	( Meta --> Meta&ob )
=putop2:	EQU #5E530 *	( Meta --> Meta&ob1&ob2 )
=swapop:	EQU #5E59E *	( Meta&ob1 --> Meta&ob2 )
=putoptwice:	EQU #5DD65 *	( Meta1 Meta2 --> Meta1&ob Meta2&ob )

*	=putop+		EQU #5BC5D *	with CHS check
*	=putop-		EQU #5BC8A *	with CHS check
*	=putop*		EQU #5BCB7 *	with INV check
*	=putop/		EQU #5BCE4 *	with INV check

=MEQ+case	EQU #5EF2E *
=MEQ-case	EQU #5EF41 *
=MEQ*case	EQU #5EF54 *
=MEQ/case	EQU #5EF67 *
=MEQCHScase	EQU #5EF7A *
=MEQINVcase	EQU #5EF8D *
=MEQ^case	EQU #5EFA0 *
=MEQSQcase	EQU #5EFB3 *
=MEQFCNcase	EQU #5EFC6 *

=NDROP0ONE	EQU #5551C *	( Meta --> %0 #1 )
=NDROP1ONE	EQU #55535 *	( Meta --> %1 #1 )
=NDROP-1ONE	EQU #5554E *	( Meta --> %-1 #1 )

* Type indicators for dispatching

=realreal	EQU #04099 * #11
=strstr		EQU #64B58 * #33
=listlist	EQU #64C66 * #55
=hxshxs		EQU #64DCE * #BB
=symsym		EQU #64DB0 * #AA
=reallist	EQU #040C1 * #15
=realidnt	EQU #040CB * #16
=reallam	EQU #040D5 * #17
=realsym	EQU #040F3 * #1A
=realhxs	EQU #040FD * #1B
=symany		EQU #64D6A * #A0
=symreal	EQU #64D74 * #A1
=symlist	EQU #64D88 * #A5
=symidnt	EQU #64D92 * #A6
=symlam		EQU #64D9C * #A7
=listreal	EQU #64C3E * #51
=hxsreal	EQU #64DC4 * #B1
=listhxs	EQU #64C84 * #5B
=idntlist	EQU #64CB6 * #65
=lamlist	EQU #64CFC * #75
RPL

* These are not in ROM

DEFINE listsym  #5A
DEFINE symsymb  #A9
DEFINE symblist #95
DEFINE symbidnt #96
DEFINE symblam  #97
DEFINE symbsymb #99
DEFINE symbsym  #9A
DEFINE hxslist  #B5
DEFINE idntidnt #66
DEFINE lamidnt  #76
DEFINE idntlam  #67
DEFINE lamlam   #77

**********************************************************************
*			Help Macros
**********************************************************************
ASSEMBLE
	IFNOPC	LCZ0
* Load Z0 into C
LCZ0		MACRO
		LC(N)	11
		CON(5)	=DOHSTR
		CON(5)	6
		CON(1)	0
LCZ0		ENDM
* Load Z1 into C
LCZ1		MACRO
		LC(N)	12
		CON(5)	=DOHSTR
		CON(5)	7
		CON(1)	1
		CON(1)	0
LCZ1		ENDM
	ENDIF
RPL

**********************************************************************
